Attribute VB_Name = "KONF_Schnittstellen"
'KEIN Option Private Module
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt :
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   KONF_Schnittstellen
' Effekt:
'   Das Modul ist die Schnittstelle zu Aufruf der Konfiguration von Gs4Word
' Restriktionen:
'   Siehe Modul KONF_Prozeduren
' Entwicklung und Test:
'   Siehe Modul KONF_Prozeduren
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   10.10.2002  Erweitet fr Version 2.60
'   18.05.2004  Normal.dot nicht sichern

' Die Eintrge in der Registry sind in GLOB_Prozeduren beschrieben (siehe dort)

'===================================================================================================
'Alle Aufrufe von KONF aus anderen Projekten
'===================================================================================================
Sub WordKonfigurierenVorlageNichtAendern()
    'Die Prozedur liest die Word-Konfiguration des Add-In aus der Registry, bietet sie in einem
    'Dialog zur nderung an und schreibt die genderte Konfiguration wieder in die Registry.
    'Da die Vorlage nicht gendert werden darf, mssen im Dialog die als Button oder Menpunkt
    'angezeigten Felder zur nderung gesperrt werden.
    'Effekt
    '   Der Dialog zur Konfiguration des Add-In wurde angezeigt.
    '   Ggf. wurde die Registry verndert.
    
    On Error GoTo Fehler_aufgetreten:

    If fbKonfiguration_lesen(sTASKNAME_WORD) = True Then
        Call fbKonfiguration_aendern(sTASKNAME_WORD, False)
        Call fbNormalDotSpeichern
    End If
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , ThisDocument.Name _
        , "WordKonfigurierenVorlageNichtAendern" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER

End Sub

Sub WordKonfigurierenVorlageIstAenderbar()
    'Die Prozedur liest die Word-Konfiguration des Add-In aus der Registry, bietet sie in einem
    'Dialog zur nderung an und schreibt die genderte Konfiguration wieder in die Registry.
    'Da die Vorlage gendert werden darf, drfen im Dialog die als Button oder Menpunkt
    'angezeigten Felder verndert werden.
    'Effekt
    '   Der Dialog zur Konfiguration des Add-In wurde angezeigt.
    '   Ggf. wurde die Registry verndert.
    
    On Error GoTo Fehler_aufgetreten:

    If fbKonfiguration_lesen(sTASKNAME_WORD) = True Then
        Call fbKonfiguration_aendern(sTASKNAME_WORD, True)
        Call fbNormalDotSpeichern
    End If
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , ThisDocument.Name _
        , "WordKonfigurierenVorlageIstAenderbar" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER

End Sub

Sub ExcelKonfigurieren()
    'Die Prozedur liest die Excel-Konfiguration des Add-In aus der Registry, bietet sie in einem
    'Dialog zur nderung an und schreibt die genderte Konfiguration wieder in die Registry.
    'Effekt
    '   Der Dialog zur Konfiguration des Add-In wurde angezeigt.
    '   Ggf. wurde die Registry verndert.
    
    On Error GoTo Fehler_aufgetreten:

    If fbKonfiguration_lesen(sTASKNAME_EXCEL) = True Then
        Call fbKonfiguration_aendern(sTASKNAME_EXCEL, True)
        Call fbNormalDotSpeichern
    End If
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , ThisDocument.Name _
        , "ExcelKonfigurieren" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER

End Sub

Sub PowerpointKonfigurieren()
    'Die Prozedur liest die Powerpoint-Konfiguration des Add-In aus der Registry, bietet sie in
    'einem Dialog zur nderung an und schreibt die genderte Konfiguration wieder in die Registry.
    'Effekt
    '   Der Dialog zur Konfiguration des Add-In wurde angezeigt.
    '   Ggf. wurde die Registry verndert.
    
    On Error GoTo Fehler_aufgetreten:

    If fbKonfiguration_lesen(sTASKNAME_POWERPOINT) = True Then
        Call fbKonfiguration_aendern(sTASKNAME_POWERPOINT, True)
        Call fbNormalDotSpeichern
    End If
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , ThisDocument.Name _
        , "PowerpointKonfigurieren" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER

End Sub

Function fbNormalDotSpeichern()
    'Ab Version 2002 versucht Word die Vorlage Normal.dot zu speichern.
    'Hier dafr sorgen, dass die Normal.dot als schon gendert gibt,
    'wenn diese Instanz von Word beendet wird.
    If NormalTemplate.Saved = False Then
        Call fbHinweisProtokollieren("Debug Hinweis 1 aus KONF_Schnittstellen.fbKonfiguration_aendern" _
            & " - " & "Normal.dot wurde veraendert" _
            & " - " & "Die Datei wird nicht gespeichert aber als gespeichert gekennzeichnet")
        NormalTemplate.Saved = True
    End If
End Function
    
'===================================================================================================
'Ende.
'===================================================================================================


