Attribute VB_Name = "MACH_Prozeduren"
Option Private Module
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   MACH_Prozeduren
' Effekt:
'   Das Modul erzeugt Alle Add-Ins fr Gs4Word.
'   -   Installation.dot (Word)
'   -   Konfiguration.dot (Word)
'   -   Gs4Word.dot (Word)
'   -   Gs4Word.xla (Excel)
'   -   Gs4Word.ppa (Powerpoint)
'   fr die Office-Versionen
'   -   Office  8.0 = Office 97
'   -   Office  9.0 = Office 2000
'   -   Office 10.0 = Office 2002
' Restriktionen:
'   Siehe Modul INST_Prozeduren
' Entwicklung und Test:
'   Siehe Modul INST_Prozeduren
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   10.10.2002  Erweitet fr Version 2.60
'   05.10.2003  Erweitert fr Ghostscript 8.11
'   25.05.2005  In fbInstallationsdateienErzeugen wird bei einem Fehler beim Kopieren der
'               Datei Gs4Word.ppt nach _sav nicht abgebrochen sondern weitergemacht.
'               (Fehler 70 Zigriff verweigert) Tritt nur bei meinem Rechner auf.
'               Zusammenhang mit den Startproblemen beim Booten?
'   02.04.2005  Erweitert fr Ghostscript 8.50 und 8.15
'   04.04.2005  Erweitert um F2 in fbInstallationAddInErzeugen
'   21.05.2005  Erweitert fr Ghostscript 8.51

'===================================================================================================
'Deklarationen
'===================================================================================================

' Konstante fr die Spracheinstellungen
'--------------------------------------
Private Const lANZAHL_SPRACHEN As Long = 3

' Die folgenden Konstanen beschreiben alle Installations-Dateien von Gs4Word
'---------------------------------------------------------------------------
Private Const sINSTALLATIONS_ADDIN As String = "Installation.dot"
Private Const sSETUP_ADDIN  As String = "Setup.dot"
Private Const sSTART_AUTOINSTALLATION_ADDIN  As String = "Start_AutoInstallation.dot"
Private Const sSTART_AUTODEINSTALLATION_ADDIN As String = "Start_AutoDeinstallation.dot"
Private Const sSTART_DIALOGINSTALLATION_ADDIN As String = "Start_DialogInstallation.dot"
Private Const sSTART_DIALOGDEINSTALLATION_ADDIN As String = "Start_DialogDeinstallation.dot"
Private Const sSTART_MAKEADDINS_ADDIN As String = "Start_MakeAddIns.dot"
Private Const sVORLAGE_ONACTION_DIALOGINSTALLATION As String = "INST_Schnittstellen.DialogInstallation"
Private Const sVORLAGE_ONACTION_DIALOGDEINSTALLATION As String = "INST_Schnittstellen.DialogDeinstallation"
Private Const sVORLAGE_CAPTION_DIALOGINSTALLATION As String = "Start_DialogInstallation"
Private Const sVORLAGE_CAPTION_DIALOGDEINSTALLATION As String = "Start_DialogDeinstallation"

' Konstante fr die Funktionen fbXXXXAddInErzeugen
'-------------------------------------------------
Private Const bERZEUGE_PRUEFEN As Byte = 0
Private Const bERZEUGE_AUS_SOURCE As Byte = 1
Public Const bERZEUGE_AUS_RUNTIME As Byte = 2
Public Const bERZEUGE_AUS_RUNTIME_MIT_TRACE As Byte = 3

'===================================================================================================
'Alle ffentlichen Variablen fr MACH_* und INST_* stehen in INST_Prozeduren
'===================================================================================================

'===================================================================================================
'Alle ffentlichen Variablen nur fr MACH_*
'===================================================================================================
Public gsSprachtexte() As String
Public gsUebersetzungen() As String

Function fbAlleAddIns_erzeugen() As Boolean
    'Die Funktion erzeugt alle Add-Ins aus den Sourcen mit allen Kommentaren
    'Sie wird von MACH_Schnittstellen.AlleAddInsErzeugen aufgerufen
    
    Dim oEinAddIn As Object
    
    'Ab Word 2000 darf Gs4Word nicht installiert sein, damit das Word-Add-In richtig erzeugt wird. Ansonsten gibt es beim Start von Word ggf. die Fehlermeldung "Sub oder Funktion nicht definiert", wenn das so erzeugte Word-Add-In verwendet wird.
    If Val(Word.Application.Version) > 8 Then
        For Each oEinAddIn In AddIns
            If LCase(oEinAddIn.Name) = LCase(sADDIN_NAME & sDOT) Then
                MsgBox fsText(sMSG_GS4WORDISTINSTALLIERT _
                    , sADDIN_NAME & sDOT) _
                    , vbExclamation, sTITEL_MACHEN
                Exit Function
            End If
        Next oEinAddIn
    End If
    
    MACH_UserForm.Show
        
End Function

Function fbInstallationsdateienPruefen(sOfficeVersion As String) As Boolean
    'Die Funktion prft, ob alle erforderlichen Dateien vorhanden sind.
    'Sie legt alle erforderlichen Verzeichnisse an

    Dim sVerzeichnisse(5) As String
    Dim vEinVerzeichnis As Variant
    Dim sDateien(10) As String
    Dim vEineDatei As Variant
    Dim lZeile As Long
    
    'Namen aller Verzeichnisse des Add-In eintragen
    sVerzeichnisse(0) = sSOURCEDIR
    sVerzeichnisse(1) = sRUNTIMEDIR
    sVerzeichnisse(2) = sSAVDIR
    sVerzeichnisse(3) = sKONFIGDIR
    sVerzeichnisse(4) = sDOKDIR
    sVerzeichnisse(5) = sLIZENZDIR
    
    'Namen aller Dateien des Add-In eintragen
    sDateien(0) = "Deutsche_Dokumentation.html"
    sDateien(1) = "Liesmich.txt"
    sDateien(2) = "english_documentation.html"
    sDateien(3) = "readme.txt"
    sDateien(4) = sKONFIGDIR & sGSINIDATEI_70x
    sDateien(5) = sKONFIGDIR & sGSINIDATEI_80x
    sDateien(6) = sKONFIGDIR & sGSINIDATEI_81x
    sDateien(7) = sKONFIGDIR & sGSINIDATEI_85x
    sDateien(8) = sKONFIGDIR & sGSTESTDATEIBASIS & sPS
    sDateien(9) = sLIZENZDIR & "gpl.txt"
    sDateien(10) = sLIZENZDIR & "Gs4Word_license.txt"
              
    If Dir(gsInstVerzeichnis & sVerzeichnisse(1), vbDirectory) = sLEER Then
        MkDir gsInstVerzeichnis & sVerzeichnisse(1)
    End If
    If Dir(gsInstVerzeichnis & sVerzeichnisse(2), vbDirectory) = sLEER Then
        MkDir gsInstVerzeichnis & sVerzeichnisse(2)
    End If
    
    'Alle Verzeichnisse prfen
    For Each vEinVerzeichnis In sVerzeichnisse
        If Dir(gsInstVerzeichnis & vEinVerzeichnis, vbDirectory) = sLEER Then
            MsgBox fsText(sMSG_VERZEICHNISFEHLT _
                , gsInstVerzeichnis & vEinVerzeichnis) _
                , vbExclamation, sTITEL_MACHEN
            fbInstallationsdateienPruefen = False
            Exit Function
        End If
    Next vEinVerzeichnis
        
    'Alle Dateien prfen
    For Each vEineDatei In sDateien
        If Dir(gsInstVerzeichnis & vEineDatei, vbNormal) = sLEER Then
            MsgBox fsText(sMSG_DATEIFEHLT _
                , gsInstVerzeichnis & vEineDatei) _
                , vbExclamation, sTITEL_MACHEN
            fbInstallationsdateienPruefen = False
            Exit Function
        End If
    Next vEineDatei
    
    fbInstallationsdateienPruefen = False
    If fbSprachsourcenErzeugen(bERZEUGE_PRUEFEN, sLEER) = True Then
        If fbStartAddInsErzeugen(sOfficeVersion, bERZEUGE_PRUEFEN) = True Then
            If fbInstallationAddInErzeugen(sOfficeVersion, bERZEUGE_PRUEFEN) = True Then
                If fbKonfigurationAddInErzeugen(sOfficeVersion, bERZEUGE_PRUEFEN) = True Then
                    If fbWordAddInErzeugen(sOfficeVersion, bERZEUGE_PRUEFEN) = True Then
                        If fbExcelAddInErzeugen(sOfficeVersion, bERZEUGE_PRUEFEN) = True Then
                            If fbPowerpointAddInErzeugen(sOfficeVersion, bERZEUGE_PRUEFEN) = True Then
                                If fbUebersetzungDokumentErzeugen(gsOfficeVersion, bERZEUGE_PRUEFEN) = True Then
                                    fbInstallationsdateienPruefen = True
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End If

End Function

Function fbInstallationsdateienErzeugen(sSourcenSwitch As String, sSprachenSwitch As String) As Boolean
    'Die Funktion erzeugt alle Add-Ins aus den Sourcen mit allen Kommentaren
    'Global:
    '   gs* wird gelesen
    'Argumente:
    '   sSourcenSwitch = Art der Sourcenerzeugung
    '       sSOURCEN_MITKOMMENTAR
    '       sSOURCEN_OHNEKOMMENTAR_OHNETRACE
    '       sSOURCEN_OHNEKOMMENTAR_MITTRACE
    '   sSprachenSwitch = Sprache fr die die Texte erzeugt werden sollen
    '       sSPRACHSWITCH_ALLESPRACHEN
    '       sSPRACHSWITCH_DEUTSCH
    '       sSPRACHSWITCH_ENGLISCH
    '       sSPRACHSWITCH_WEITERESPRACHE
    'Rckgabewert:
    '   True = Alle Add-Ins erzeugt
    'Effekt
    '   Alle alten Add-Ins gesichert
    '   Alle Add-Ins erzeugt

    Dim bAktion As Byte
    Dim sSprachcode As String
    Dim sDateien(10) As String
    Dim vEineDatei As Variant
    Dim sTimestamp As String
    Dim iZeile As Integer
    
    fbInstallationsdateienErzeugen = False
    
    'sSourcenSwitch in bAktion transformieren
    'Erzeugen aus Sourcen oder Runtime oder Runtime mit Trace
    Select Case sSourcenSwitch
        Case sSOURCEN_MITKOMMENTAR
            bAktion = bERZEUGE_AUS_SOURCE
        Case sSOURCEN_OHNEKOMMENTAR_OHNETRACE
            bAktion = bERZEUGE_AUS_RUNTIME
        Case sSOURCEN_OHNEKOMMENTAR_MITTRACE
             bAktion = bERZEUGE_AUS_RUNTIME_MIT_TRACE
        Case Else
            Exit Function
    End Select
       
    'sSprachenSwitch in sSprachcode transformieren
    'Erzeugen fr alle oder eine Sprache
    Select Case sSprachenSwitch
        Case sSPRACHSWITCH_ALLESPRACHEN
            sSprachcode = sLEER
        Case sSPRACHSWITCH_DEUTSCH
            sSprachcode = sSPRACHCODE_DEUTSCH
        Case sSPRACHSWITCH_ENGLISCH
            sSprachcode = sSPRACHCODE_ENGLISCH
        Case sSPRACHSWITCH_WEITERESPRACHE
            sSprachcode = sSPRACHCODE_WEITERESPRACHE
        Case Else
            Exit Function
    End Select
    
    sDateien(0) = sINSTALLATIONS_ADDIN
    sDateien(1) = sKONFIGURATIONS_ADDIN
    sDateien(2) = gsWordAddIn
    sDateien(3) = gsExcelAddIn
    sDateien(4) = gsPowerpointAddIn
    sDateien(5) = gsUebersetzungDokument
    sDateien(6) = sSETUP_ADDIN
    sDateien(7) = sSTART_AUTOINSTALLATION_ADDIN
    sDateien(8) = sSTART_AUTODEINSTALLATION_ADDIN
    sDateien(9) = sSTART_DIALOGINSTALLATION_ADDIN
    sDateien(10) = sSTART_DIALOGDEINSTALLATION_ADDIN
    sTimestamp = Format(Now, "_yyyymmDd_hhnnss")
    
    If LCase(gsInstVerzeichnis & sINSTALLATIONS_ADDIN) = _
    LCase(ThisDocument.Path & "\" & ThisDocument.Name) Then
        MsgBox fsText(sMSG_KEINEKOPIEDESINSTADDIN _
            , ThisDocument.Path & "\" & ThisDocument.Name) _
            , vbExclamation, sTITEL_MACHEN
        Exit Function
    End If
            
    'Sicherungsverzeichnis anlegen
    If Dir(gsInstVerzeichnis & sSAVDIR, vbDirectory) = sLEER Then
        MkDir (gsInstVerzeichnis & sSAVDIR)
    End If
    
    'Alle Add-Ins sichern
    For Each vEineDatei In sDateien
        If Dir(gsInstVerzeichnis & vEineDatei, vbNormal) <> sLEER Then
            If fbDatei_kopieren(gsInstVerzeichnis & vEineDatei, gsInstVerzeichnis _
            & sSAVDIR & vEineDatei & sTimestamp) = False Then
                'Exit Function
            End If
        End If
    Next vEineDatei
    
    'Alle Add-Ins lschen
    For Each vEineDatei In sDateien
        If fbDatei_loeschen(gsInstVerzeichnis & vEineDatei) = False Then
            Exit Function
        End If
    Next vEineDatei
        
    'Es kann sein, dass sSTART_MAKEADDINS_ADDIN gesperrt ist
    'Deshalb nur versuchen
    On Error Resume Next
    FileCopy gsInstVerzeichnis & vEineDatei, gsInstVerzeichnis & sSAVDIR & vEineDatei & sTimestamp
    Kill gsInstVerzeichnis & sSTART_MAKEADDINS_ADDIN
    On Error GoTo 0
        
    'bersetzungsdokument erzeugen, wenn alle Sprachen gewhlt wurden
    If sSprachcode = sLEER Then
        If fbUebersetzungDokumentErzeugen(gsOfficeVersion, bAktion) = False Then
            Exit Function
        End If
    End If
    
    'Alle Add-Ins erzeugen
    If fbSprachsourcenErzeugen(bAktion, sSprachcode) = True Then
        If fbStartAddInsErzeugen(gsOfficeVersion, bAktion) = True Then
            If fbInstallationAddInErzeugen(gsOfficeVersion, bAktion) = True Then
                If fbKonfigurationAddInErzeugen(gsOfficeVersion, bAktion) = True Then
                    If fbWordAddInErzeugen(gsOfficeVersion, bAktion) = True Then
                        If fbExcelAddInErzeugen(gsOfficeVersion, bAktion) = True Then
                            If fbPowerpointAddInErzeugen(gsOfficeVersion, bAktion) = True Then
                                Select Case bAktion
                                Case bERZEUGE_AUS_SOURCE
                                    MsgBox fsText(sALLEADDINSERZEUGT_MIT) _
                                        , vbInformation, sTITEL_MACHEN
                                Case bERZEUGE_AUS_RUNTIME
                                    MsgBox fsText(sALLEADDINSERZEUGT_OHNE) _
                                        , vbInformation, sTITEL_MACHEN
                                Case bERZEUGE_AUS_RUNTIME_MIT_TRACE
                                    MsgBox fsText(sALLEADDINSERZEUGT_TRACE) _
                                        , vbInformation, sTITEL_MACHEN
                                End Select
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End If
    fbInstallationsdateienErzeugen = True
        
End Function

Function fbStartAddInsErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Const sKEINAUTONEW_DE As String = "Wenn Sie diesen Text sehen, hat Word das Makro nicht automatisch gestartet. Dafr kann es unterschiedlich Ursachen geben.(&n)Eventuell ist die Sicherheitsstufe zum Ausfhren von Makros zu restriktiv. Setzen Sie die Sicherheitsstufe zum Ausfhren von Makros whrend der Installation auf 'Mittel' oder Niedrig'. Nach der Installation kann sie wieder auf 'Hoch' gesetzt werden.(&n)Eventuell ist der Dateityp 'DOT - Microsoft Word-Dokumentvorlage' nicht richtig verknpft. Stellen Sie den Dateityp wieder her.(&n)Weitere Informationen finden Sie in der Dokumentation zum Installations-Add-In."
    Const sKEINAUTONEW_EN As String = "If you see this text, Word did not start the installation program as it should. There are several possibilities.(&n)Most likely your security settings are too strict for Word macros to execute. Set macro security to 'Medium' or 'Low' before installing. After the installation you may set it back to 'High'.(&n)Or perhaps the extension 'DOT - Microsoft Word Template' is not correctly associated.(&n)See then German documentation about the 'Installation Add-in' for more Information."
    'Const sKEINAUTONEW_DE As String = "Wenn Sie diesen Text sehen, ist die Sicherheitsstufe zum Ausfhren von Makros zu restriktiv. Setzen Sie die Sicherheitsstufe zum Ausfhren von Makros auf 'Mittel'. Weitere Informationen finden Sie in der Dokumentation zum Installations-Add-In."
    'Const sKEINAUTONEW_EN As String = "If you see this text you're security settings are too restrict for this installer to run. See then german documentation about the ' Installations-Add-In' for more Information."
    
    Dim oWord As Object
    'Dim oDokument As Object
    Dim oControl As Object
    Dim iFehlerNummer As Integer
    Dim vEineDatei As Variant
    Dim sDateien(1) As String
    Dim sSourcePfad As String
    Dim bSavePropertiesPromptFlag As Boolean
    'Namen der einen Source des Add-In eintragen
    sDateien(0) = "START_Schnittstelle4Inst.bas"
    sDateien(1) = "START_Schnittstelle4Make.bas"
       
    Dim iNr As Integer
    Dim sDateienAddIns(5, 1) As String
    Dim sEineDotDatei As String
    Dim sEineBasDatei As String
    Dim vEineDateiBasis As Variant
    'Basis-Namen aller Dateien eintragen
    sDateienAddIns(0, 0) = sSETUP_ADDIN
    sDateienAddIns(0, 1) = sDateien(0)
    sDateienAddIns(1, 0) = sSTART_AUTOINSTALLATION_ADDIN
    sDateienAddIns(1, 1) = sDateien(0)
    sDateienAddIns(2, 0) = sSTART_AUTODEINSTALLATION_ADDIN
    sDateienAddIns(2, 1) = sDateien(0)
    sDateienAddIns(3, 0) = sSTART_DIALOGINSTALLATION_ADDIN
    sDateienAddIns(3, 1) = sDateien(0)
    sDateienAddIns(4, 0) = sSTART_DIALOGDEINSTALLATION_ADDIN
    sDateienAddIns(4, 1) = sDateien(0)
    sDateienAddIns(5, 0) = sSTART_MAKEADDINS_ADDIN
    sDateienAddIns(5, 1) = sDateien(1)
    
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & sSOURCEDIR & vEineDatei, vbNormal) = sLEER Then
                MsgBox fsText(sMSG_SOURCEFEHLT _
                    , gsInstVerzeichnis & sSOURCEDIR & CStr(vEineDatei)) _
                    , vbExclamation, sTITEL_MACHEN
                fbStartAddInsErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbStartAddInsErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                False)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_RUNTIME_MIT_TRACE
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                True)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & sSOURCEDIR
    End Select
    
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_WORD, sOfficeVersion) = False Then
        fbStartAddInsErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbStartAddInsErzeugen = True
    
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox fsText(sMSG_KEINEWEITEREVERBINDUNGZUWORD) _
            , vbExclamation, sTITEL_MACHEN
        fbStartAddInsErzeugen = False
    End If
    
    If fbStartAddInsErzeugen = True Then
    
        'Word Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht eingreifen,
        'falls das Erzeugen des Dokuments nicht funktioniert.
        oWord.Visible = True
        oWord.WindowState = wdWindowStateMinimize
        
        'Status fr die Anzeige der Eigengschaftsfensters merken und zurcksetzen
        bSavePropertiesPromptFlag = oWord.Options.SavePropertiesPrompt
        oWord.Options.SavePropertiesPrompt = False
    
        For iNr = LBound(sDateienAddIns) To UBound(sDateienAddIns)
            sEineDotDatei = gsInstVerzeichnis & sDateienAddIns(iNr, 0)
            sEineBasDatei = sSourcePfad & sDateienAddIns(iNr, 1)

            If Dir(sEineDotDatei, vbNormal) = sLEER Then

                'Zuerst wird das neue Add-In leer angelegt
                oWord.Documents.Add NewTemplate:=True
                
                'Dann wird der Text hineingeschrieben
                oWord.Selection.WholeStory
                oWord.Selection.Delete
                oWord.Selection.Collapse Direction:=wdCollapseEnd
                oWord.Selection.InsertAfter ("Deutsch")
                oWord.Selection.Font.Size = 12
                oWord.Selection.Font.Bold = True
                oWord.Selection.InsertAfter (vbCrLf)
                oWord.Selection.Collapse Direction:=wdCollapseEnd
                oWord.Selection.InsertAfter (fsText(sKEINAUTONEW_DE))
                oWord.Selection.Font.Size = 10
                oWord.Selection.Font.Bold = False
                oWord.Selection.InsertAfter (vbCrLf & vbCrLf)
                oWord.Selection.Collapse Direction:=wdCollapseEnd
                oWord.Selection.InsertAfter ("English")
                oWord.Selection.Font.Size = 12
                oWord.Selection.Font.Bold = True
                oWord.Selection.InsertAfter (vbCrLf)
                oWord.Selection.Collapse Direction:=wdCollapseEnd
                oWord.Selection.InsertAfter (fsText(sKEINAUTONEW_EN))
                oWord.Selection.Font.Size = 10
                oWord.Selection.Font.Bold = False
                
                'Add-In speichern
                oWord.ActiveDocument.SaveAs _
                    FileName:=sEineDotDatei, _
                    FileFormat:=wdFormatTemplate
                    
                'Source in das Add-In laden
                On Error Resume Next
                oWord.ActiveDocument.VBProject.vbcomponents.Import (sEineBasDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox fsText(sMSG_WORDSOURCENICHTLADBAR) _
                        , vbExclamation, sTITEL_MACHEN
                    fbStartAddInsErzeugen = False
                    Exit For
                End If
            
                If fbStartAddInsErzeugen = True Then
                
                    'Projektname und Beschreibung eintragen
                    On Error Resume Next
                    oWord.ActiveDocument.VBProject.Name = sADDIN_NAME
                
                    'Add-In nochmal speichern
                    oWord.ActiveDocument.SaveAs _
                        FileName:=sEineDotDatei, _
                        FileFormat:=wdFormatTemplate
                    
                    On Error Resume Next
                    oWord.ActiveDocument.Close SaveChanges:=wdSaveChanges
                    iFehlerNummer = Err.Number
                    On Error GoTo 0
                    If iFehlerNummer <> 0 Then
                        MsgBox fsText(sMSG_STARTADDINNICHTERZEUGT, sEineDotDatei) _
                            , vbExclamation, sTITEL_MACHEN
                        fbStartAddInsErzeugen = False
                        Exit For
                    End If
                Else
                    On Error Resume Next
                    oWord.ActiveDocument.Close SaveChanges:=wdDoNotSaveChanges
                    On Error GoTo 0
                End If
            End If
        
        Next iNr
            
        'Status fr die Anzeige der Eigengschaftsfensters wieder auf dem gemerkten Wert setzen
        oWord.Options.SavePropertiesPrompt = bSavePropertiesPromptFlag
        
        oWord.Quit SaveChanges:=wdDoNotSaveChanges
        Set oWord = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_WORD, sOfficeVersion)

End Function

Function fbInstallationAddInErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Const sTEXT_DE As String = "Das Add-In kann ohne Microsoft Word, Ghostscript, einem PostScript-Drucker-Treiber und einem PDF-Betrachter nicht sinnvoll verwendet werden. In der Komplettinstallation sind alle erforderlichen Programme enthalten.(&n)Unterhalb der Menzeile finden Sie eine neue Leiste mit zwei Buttons. Damit knnen Sie Gs4Word installierten oder deinstallieren. Wenn die Buttons nicht sichtbar sind, drcken Sie die Funktionstaste F2."
    Const sTEXT_EN As String = "The Add-in cannot be used without Microsoft Word, Ghostscript, a PostScript printer driver and a PDF viewer to operate properly.(&n)You find a new strip below the menu line with two buttons. You can install or deinstall Gs4Word with that. If the buttons are not visible press function key F2."
    
    Dim oWord As Object
    'Dim oEinCommandBar As Object
    Dim oControl As Object
    Dim iFehlerNummer As Integer
    Dim vEineDatei As Variant
    Dim sDateien(14) As String
    Dim sSourcePfad As String
    Dim bSavePropertiesPromptFlag As Boolean
    
    'Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "GLOB_Prozeduren.bas"
    sDateien(1) = "GLOB_Texte.bas"
    sDateien(2) = "INST_Prozeduren.bas"
    sDateien(3) = "INST_Schnittstellen.bas"
    sDateien(4) = "INST_Texte.bas"
    sDateien(5) = "INST_UF_Deinstallation.frm"
    sDateien(6) = "INST_UF_Installation.frm"
    sDateien(7) = "INST_UF_Sprache.frm"
    sDateien(8) = "MACH_Prozeduren.bas"
    sDateien(9) = "MACH_Schnittstellen.bas"
    sDateien(10) = "MACH_Texte.bas"
    sDateien(11) = "MACH_UserForm.frm"
    sDateien(12) = "REG_Prozeduren.bas"
    sDateien(13) = "TECH_Prozeduren.bas"
    sDateien(14) = "TECH_Texte.bas"
       
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & sSOURCEDIR & vEineDatei, vbNormal) = sLEER Then
                MsgBox fsText(sMSG_SOURCEFEHLT _
                    , gsInstVerzeichnis & sSOURCEDIR & CStr(vEineDatei)) _
                    , vbExclamation, sTITEL_MACHEN
                fbInstallationAddInErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbInstallationAddInErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                False)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_RUNTIME_MIT_TRACE
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                True)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & sSOURCEDIR
    End Select
        
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_WORD, sOfficeVersion) = False Then
        fbInstallationAddInErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbInstallationAddInErzeugen = True
    
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox fsText(sMSG_KEINEWEITEREVERBINDUNGZUWORD) _
            , vbExclamation, sTITEL_MACHEN
        fbInstallationAddInErzeugen = False
    End If
    
    If fbInstallationAddInErzeugen = True Then
    
        'Word Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht eingreifen,
        'falls das Erzeugen des Add-In nicht funktioniert.
        oWord.Visible = True
        oWord.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Add-In leer angelegt
        oWord.Documents.Add NewTemplate:=True
        
        'Dann wird der Text hineingeschrieben
        oWord.Selection.WholeStory
        oWord.Selection.Delete
        oWord.Selection.Collapse Direction:=wdCollapseEnd
        oWord.Selection.InsertAfter ("Deutsch")
        oWord.Selection.Font.Size = 12
        oWord.Selection.Font.Bold = True
        oWord.Selection.InsertAfter (vbCrLf)
        oWord.Selection.Collapse Direction:=wdCollapseEnd
        oWord.Selection.InsertAfter (fsText(sTEXT_DE))
        oWord.Selection.Font.Size = 10
        oWord.Selection.Font.Bold = False
        oWord.Selection.InsertAfter (vbCrLf & vbCrLf)
        oWord.Selection.Collapse Direction:=wdCollapseEnd
        oWord.Selection.InsertAfter ("English")
        oWord.Selection.Font.Size = 12
        oWord.Selection.Font.Bold = True
        oWord.Selection.InsertAfter (vbCrLf)
        oWord.Selection.Collapse Direction:=wdCollapseEnd
        oWord.Selection.InsertAfter (fsText(sTEXT_EN))
        oWord.Selection.Font.Size = 10
        oWord.Selection.Font.Bold = False
                
        'Status fr die Anzeige der Eigengschaftsfensters merken und zurcksetzen
        bSavePropertiesPromptFlag = oWord.Options.SavePropertiesPrompt
        oWord.Options.SavePropertiesPrompt = False
    
        'Add-In speichern
        oWord.ActiveDocument.SaveAs _
            FileName:=gsInstVerzeichnis & sINSTALLATIONS_ADDIN, _
            FileFormat:=wdFormatTemplate
           
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oWord.ActiveDocument.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox fsText(sMSG_WORDSOURCENICHTLADBAR) _
                        , vbExclamation, sTITEL_MACHEN
                    fbInstallationAddInErzeugen = False
                    Exit For
                End If
            End If
        Next vEineDatei
        
        If fbInstallationAddInErzeugen = True Then
        
            'Alle Mens verbergen
            'For Each oEinCommandBar In oWord.CommandBars
            '    If oEinCommandBar.Visible = True _
            '    And oEinCommandBar.Name <> "Menu Bar" Then
            '        'MsgBox oEinCommandBar.Name
            '        oEinCommandBar.Visible = False
            '    End If
            'Next oEinCommandBar

            'Neues Menu einfgen
            oWord.CommandBars.Add(Name:=sADDIN_NAME, Position:=msoBarTop).Visible = True
            Set oControl = oWord.CommandBars(sADDIN_NAME).Controls.Add(Type:=msoControlButton, ID:=1, _
                Before:=1, temporary:=False)
            With oControl
                .FaceId = 2144
                .Caption = sVORLAGE_CAPTION_DIALOGDEINSTALLATION
                .Style = msoButtonIconAndCaption
                .OnAction = sVORLAGE_ONACTION_DIALOGDEINSTALLATION
                .Enabled = True
                .Visible = True
                .BeginGroup = True
            End With
            Set oControl = oWord.CommandBars(sADDIN_NAME).Controls.Add(Type:=msoControlButton, ID:=1, _
                Before:=1, temporary:=False)
            With oControl
                .FaceId = 2144
                .Caption = sVORLAGE_CAPTION_DIALOGINSTALLATION
                .Style = msoButtonIconAndCaption
                .OnAction = sVORLAGE_ONACTION_DIALOGINSTALLATION
                .Enabled = True
                .Visible = True
                .BeginGroup = True
            End With
            
            'Projektname und Beschreibung eintragen
            oWord.ActiveDocument.VBProject.Name = sADDIN_NAME
            
            'Add-In noch mal speichern
            'Ohne dieses zustzliche Speichern als Template funktioniert bei Office97 die Prozedur
            'AutoExec im erzeugten Add-In nicht, wenn die unvernderte Source verwendet wird. Wurde
            'die Source zuvor mit fbSourceOhneKommentar_erzeugen verndert, gibt es keine Probleme.
            'Die Source ohne Kommentare unterscheidet sich von der Originalsource durch ihre
            'fehlerhafte Formatierung. Die Einrckungen am Zeilenanfang fehlen.
            '17.8.2002 Es funktioniert doch nicht immer
            oWord.ActiveDocument.SaveAs _
                FileName:=gsInstVerzeichnis & sINSTALLATIONS_ADDIN, _
                FileFormat:=wdFormatTemplate
        
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdSaveChanges
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox fsText(sMSG_INSTALLATIONSADDINNICHTERZEUGT) _
                    , vbExclamation, sTITEL_MACHEN
                fbInstallationAddInErzeugen = False
            Else
                fbInstallationAddInErzeugen = True
            End If
        Else
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdDoNotSaveChanges
            On Error GoTo 0
        End If
        
        'Status fr die Anzeige der Eigengschaftsfensters wieder auf dem gemerkten Wert setzen
        oWord.Options.SavePropertiesPrompt = bSavePropertiesPromptFlag
        
        oWord.Quit SaveChanges:=wdDoNotSaveChanges
        Set oWord = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_WORD, sOfficeVersion)

End Function

Function fbKonfigurationAddInErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Dim oWord As Object
    Dim iFehlerNummer As Integer
    Dim vEineDatei As Variant
    Dim sDateien(8) As String
    Dim sSourcePfad As String
    Dim bSavePropertiesPromptFlag As Boolean
    
    'Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "GLOB_Prozeduren.bas"
    sDateien(1) = "GLOB_Texte.bas"
    sDateien(2) = "TECH_Prozeduren.bas"
    sDateien(3) = "TECH_Texte.bas"
    sDateien(4) = "KONF_Prozeduren.bas"
    sDateien(5) = "KONF_Schnittstellen.bas"
    sDateien(6) = "KONF_UserForm.frm"
    sDateien(7) = "KONF_Texte.bas"
    sDateien(8) = "REG_Prozeduren.bas"
       
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & sSOURCEDIR & vEineDatei, vbNormal) = sLEER Then
                MsgBox fsText(sMSG_SOURCEFEHLT _
                    , gsInstVerzeichnis & sSOURCEDIR & CStr(vEineDatei)) _
                    , vbExclamation, sTITEL_MACHEN
                fbKonfigurationAddInErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbKonfigurationAddInErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                False)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_RUNTIME_MIT_TRACE
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                True)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & sSOURCEDIR
    End Select
    
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_WORD, sOfficeVersion) = False Then
        fbKonfigurationAddInErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbKonfigurationAddInErzeugen = True
    
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox fsText(sMSG_KEINEWEITEREVERBINDUNGZUWORD) _
            , vbExclamation, sTITEL_MACHEN
        fbKonfigurationAddInErzeugen = False
    End If
    
    If fbKonfigurationAddInErzeugen = True Then
    
        'Word Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht eingreifen,
        'falls das Erzeugen des Add-In nicht funktioniert.
        oWord.Visible = True
        oWord.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Add-In leer angelegt
        oWord.Documents.Add NewTemplate:=True
        
        'Status fr die Anzeige der Eigengschaftsfensters merken und zurcksetzen
        bSavePropertiesPromptFlag = oWord.Options.SavePropertiesPrompt
        oWord.Options.SavePropertiesPrompt = False
    
        'Add-In speichern
        oWord.ActiveDocument.SaveAs _
            FileName:=gsInstVerzeichnis & sKONFIGURATIONS_ADDIN, _
            FileFormat:=wdFormatTemplate
            
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oWord.ActiveDocument.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox fsText(sMSG_WORDSOURCENICHTLADBAR) _
                        , vbExclamation, sTITEL_MACHEN
                    fbKonfigurationAddInErzeugen = False
                    Exit For
                End If
            End If
        Next vEineDatei
        
        If fbKonfigurationAddInErzeugen = True Then
        
            'Projektname und Beschreibung eintragen
            oWord.ActiveDocument.VBProject.Name = sADDIN_NAME
            
            'Add-In noch mal speichern
            'Ohne dieses zustzliche Speichern als Template funktioniert bei Office97 die Prozedur
            'AutoExec im erzeugten Add-In nicht, wenn die unvernderte Source verwendet wird. Wurde
            'die Source zuvor mit fbSourceOhneKommentar_erzeugen verndert, gibt es keine Probleme.
            'Die Source ohne Kommentare unterscheidet sich von der Originalsource durch ihre
            'fehlerhafte Formatierung. Die Einrckungen am Zeilenanfang fehlen.
            '17.8.2002 Es funktioniert doch nicht immer
            oWord.ActiveDocument.SaveAs _
                FileName:=gsInstVerzeichnis & sKONFIGURATIONS_ADDIN, _
                FileFormat:=wdFormatTemplate
        
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdSaveChanges
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox fsText(sMSG_KONFIGADDINNICHTERZEUGT) _
                    , vbExclamation, sTITEL_MACHEN
                fbKonfigurationAddInErzeugen = False
            Else
                fbKonfigurationAddInErzeugen = True
            End If
        Else
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdDoNotSaveChanges
            On Error GoTo 0
        End If
        
        'Status fr die Anzeige der Eigengschaftsfensters wieder auf dem gemerkten Wert setzen
        oWord.Options.SavePropertiesPrompt = bSavePropertiesPromptFlag
        
        oWord.Quit SaveChanges:=wdDoNotSaveChanges
        Set oWord = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_WORD, sOfficeVersion)

End Function

Function fbWordAddInErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Dim oWord As Object
    Dim iFehlerNummer As Integer

    Dim sDateien(5) As String
    Dim vEineDatei As Variant
    Dim sSourcePfad As String
    Dim bSavePropertiesPromptFlag As Boolean
    
    '(1) Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "GLOB_Prozeduren.bas"
    sDateien(1) = "GLOB_Texte.bas"
    sDateien(2) = "GLOB_UserForm.frm"
    sDateien(3) = "DOC_Prozeduren.bas"
    sDateien(4) = "DOC_Schnittstellen.bas"
    sDateien(5) = "DOC_Texte.bas"
    
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & sSOURCEDIR & vEineDatei, vbNormal) = sLEER Then
                MsgBox fsText(sMSG_SOURCEFEHLT _
                    , gsInstVerzeichnis & sSOURCEDIR & CStr(vEineDatei)) _
                    , vbExclamation, sTITEL_MACHEN
                fbWordAddInErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbWordAddInErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                False)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_RUNTIME_MIT_TRACE
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                True)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & sSOURCEDIR
    End Select
    
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_WORD, sOfficeVersion) = False Then
        fbWordAddInErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbWordAddInErzeugen = True
    
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox fsText(sMSG_KEINEWEITEREVERBINDUNGZUWORD) _
            , vbExclamation, sTITEL_MACHEN
        fbWordAddInErzeugen = False
    End If
    
    If fbWordAddInErzeugen = True Then
    
        'Word Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht eingreifen,
        'falls das Erzeugen des Add-In nicht funktioniert.
        oWord.Visible = True
        oWord.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Add-In leer angelegt
        oWord.Documents.Add NewTemplate:=True
        
        'Status fr die Anzeige der Eigengschaftsfensters merken und zurcksetzen
        bSavePropertiesPromptFlag = oWord.Options.SavePropertiesPrompt
        oWord.Options.SavePropertiesPrompt = False
    
        'Add-In speichern
        oWord.ActiveDocument.SaveAs _
            FileName:=gsInstVerzeichnis & gsWordAddIn, _
            FileFormat:=wdFormatTemplate
            
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oWord.ActiveDocument.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox fsText(sMSG_WORDSOURCENICHTLADBAR) _
                        , vbExclamation, sTITEL_MACHEN
                    fbWordAddInErzeugen = False
                    Exit For
                End If
            End If
        Next vEineDatei
        
        If fbWordAddInErzeugen = True Then
        
            'Projektname und Beschreibung eintragen
            oWord.ActiveDocument.VBProject.Name = sADDIN_NAME
            
            'Add-In noch mal speichern
            'Ohne dieses zustzliche Speichern als Template funktioniert bei Office97 die Prozedur
            'AutoExec im erzeugten Add-In nicht, wenn die unvernderte Source verwendet wird. Wurde
            'die Source zuvor mit fbSourceOhneKommentar_erzeugen verndert, gibt es keine Probleme.
            'Die Source ohne Kommentare unterscheidet sich von der Originalsource durch ihre
            'fehlerhafte Formatierung. Die Einrckungen am Zeilenanfang fehlen.
            '17.8.2002 Es funktioniert doch nicht immer
            oWord.ActiveDocument.SaveAs _
                FileName:=gsInstVerzeichnis & gsWordAddIn, _
                FileFormat:=wdFormatTemplate
        
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdSaveChanges
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox fsText(sMSG_WORDADDINNICHTERZEUGT) _
                    , vbExclamation, sTITEL_MACHEN
                fbWordAddInErzeugen = False
            Else
                fbWordAddInErzeugen = True
            End If
        Else
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdDoNotSaveChanges
            On Error GoTo 0
        End If
        
        'Status fr die Anzeige der Eigengschaftsfensters wieder auf dem gemerkten Wert setzen
        oWord.Options.SavePropertiesPrompt = bSavePropertiesPromptFlag
        
        oWord.Quit SaveChanges:=wdDoNotSaveChanges
        Set oWord = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_WORD, sOfficeVersion)
    
End Function

Function fbExcelAddInErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Dim oExcel As Object
    Dim iFehlerNummer As Integer

    Dim sDateien(5) As String
    Dim vEineDatei As Variant
    Dim sSourcePfad As String
    Dim sWorkbookname As String
    
    '(1) Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "GLOB_Prozeduren.bas"
    sDateien(1) = "GLOB_Texte.bas"
    sDateien(2) = "GLOB_UserForm.frm"
    sDateien(3) = "XLS_Prozeduren.bas"
    sDateien(4) = "XLS_Schnittstellen.bas"
    sDateien(5) = "XLS_Texte.bas"
    
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & sSOURCEDIR & vEineDatei, vbNormal) = sLEER Then
                MsgBox fsText(sMSG_SOURCEFEHLT _
                    , gsInstVerzeichnis & sSOURCEDIR & CStr(vEineDatei)) _
                    , vbExclamation, sTITEL_MACHEN
                fbExcelAddInErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbExcelAddInErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                False)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_RUNTIME_MIT_TRACE
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                True)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & sSOURCEDIR
    End Select
    
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_EXCEL, sOfficeVersion) = False Then
        fbExcelAddInErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbExcelAddInErzeugen = True
    
    'Excel-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oExcel Nothing
    Set oExcel = CreateObject("Excel.Application") 'Erzeugt einen neue Instanz von Excel
    On Error GoTo 0
    If oExcel Is Nothing Then
        MsgBox fsText(sMSG_KEINEVERBINDUNGZUEXCEL) _
            , vbExclamation, sTITEL_MACHEN
        fbExcelAddInErzeugen = False
    End If
    
    If fbExcelAddInErzeugen = True Then
    
        'Excel Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht eingreifen,
        'falls das Erzeugen des Add-In nicht funktioniert.
        oExcel.Visible = True
        oExcel.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Add-In leer angelegt
        oExcel.Workbooks.Add
        
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oExcel.ActiveWorkbook.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox fsText(sMSG_EXCELSOURCENICHTLADBAR) _
                        , vbExclamation, sTITEL_MACHEN
                    fbExcelAddInErzeugen = False
                    Exit For
                End If
            End If
        Next vEineDatei
        
        If fbExcelAddInErzeugen = True Then
        
            'Projektname und Beschreibung eintragen
            oExcel.ActiveWorkbook.VBProject.Name = sADDIN_NAME
                    
            'Add-In speichern
            'Dazu muss das Workbook als Add-In gekennzeichnet werden. Danach wird es nicht mehr als
            'ActiveWorkbook erkannt und muss mit seinem Namen angesprochen werden.
            sWorkbookname = oExcel.ActiveWorkbook.Name
            On Error Resume Next
            oExcel.ActiveWorkbook.IsAddin = True
            iFehlerNummer = Err.Number
            If iFehlerNummer = 0 Then
                oExcel.Workbooks(sWorkbookname).SaveAs _
                    FileName:=gsInstVerzeichnis & gsExcelAddIn, _
                    FileFormat:=18 '18 = xlAddIn
                iFehlerNummer = Err.Number
            End If
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox fsText(sMSG_EXCELADDINNICHTERZEUGT) _
                    , vbExclamation, sTITEL_MACHEN
                fbExcelAddInErzeugen = False
            Else
                fbExcelAddInErzeugen = True
            End If
        End If
        If fbExcelAddInErzeugen = False Then
            On Error Resume Next
            oExcel.ActiveWorkbook.Close SaveChanges:=False
            On Error GoTo 0
        End If
        
        oExcel.Quit
        Set oExcel = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_EXCEL, sOfficeVersion)

End Function

Function fbPowerpointAddInErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Dim oPowerpoint As Object
    Dim iFehlerNummer As Integer

    Dim sDateien(5) As String
    Dim vEineDatei As Variant
    Dim sSourcePfad As String
    
    '(1) Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "GLOB_Prozeduren.bas"
    sDateien(1) = "GLOB_Texte.bas"
    sDateien(2) = "GLOB_UserForm.frm"
    sDateien(3) = "PPT_Prozeduren.bas"
    sDateien(4) = "PPT_Schnittstellen.bas"
    sDateien(5) = "PPT_Texte.bas"
        
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & sSOURCEDIR & vEineDatei, vbNormal) = sLEER Then
                MsgBox fsText(sMSG_SOURCEFEHLT _
                    , gsInstVerzeichnis & sSOURCEDIR & CStr(vEineDatei)) _
                    , vbExclamation, sTITEL_MACHEN
                fbPowerpointAddInErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbPowerpointAddInErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                False)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_RUNTIME_MIT_TRACE
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                True)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & sSOURCEDIR
    End Select
    
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_POWERPOINT, sOfficeVersion) = False Then
        fbPowerpointAddInErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbPowerpointAddInErzeugen = True
    
    'Powerpoint-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oPowerpoint Nothing
    Set oPowerpoint = CreateObject("Powerpoint.Application") 'Erzeugt einen neue Instanz von Powerpoint
    On Error GoTo 0
    If oPowerpoint Is Nothing Then
        MsgBox fsText(sMSG_KEINEVERBINDUNGZUPOWERPOINT) _
            , vbExclamation, sTITEL_MACHEN
        fbPowerpointAddInErzeugen = False
    End If
    
    If fbPowerpointAddInErzeugen = True Then
    
        'Powerpoint Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht
        'eingreifen, falls das Erzeugen des Add-In nicht funktioniert.
        '   In Office 10.0 muss Visible=True sein, sonst kann Powerpoint das Add-In nicht erzeugen!
        '   Oder ist es etwas anderes, das gleichzeitig mit Visiable aktiviert wird?
        oPowerpoint.Visible = True
        oPowerpoint.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Add-In leer angelegt
        oPowerpoint.Presentations.Add
        
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oPowerpoint.ActivePresentation.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox fsText(sMSG_POWERPOINTSOURCENICHTLADBAR) _
                        , vbExclamation, sTITEL_MACHEN
                    fbPowerpointAddInErzeugen = False
                    Exit For
                End If
            End If
        Next vEineDatei
        
        'Projektname und Beschreibung eintragen
        oPowerpoint.ActivePresentation.VBProject.Name = sADDIN_NAME
            
        'Add-In speichern
        On Error Resume Next
        oPowerpoint.ActivePresentation.SaveAs gsInstVerzeichnis & gsPowerpointAddIn, 8 '8 = ppSaveAsAddIn
        iFehlerNummer = Err.Number
        If iFehlerNummer <> 0 Then
            MsgBox fsText(sMSG_POWERPOINTADDINNICHTERZEUGT) _
                , vbExclamation, sTITEL_MACHEN
            fbPowerpointAddInErzeugen = False
        End If
            
        If fbPowerpointAddInErzeugen = True Then
            On Error Resume Next
            oPowerpoint.ActivePresentation.Close
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox fsText(sMSG_POWERPOINTADDINNICHTERZEUGT) _
                    , vbExclamation, sTITEL_MACHEN
                fbPowerpointAddInErzeugen = False
            Else
                fbPowerpointAddInErzeugen = True
            End If
        Else
            On Error Resume Next
            oPowerpoint.ActivePresentation.Close
            On Error GoTo 0
        End If
        
        If fbPowerpointAddInErzeugen = True _
        And Dir(gsInstVerzeichnis & gsPowerpointAddIn, vbNormal) = sLEER Then
            'unter Office 10.0 erzeugt Powerpoint einfach kein Add-In wenn es fehlerhaft ist
            'Dabei meldet Powerpoint keinen Fehler!
            'Unter Office 10.0 erzeugt Powerpoint ebenfalls kein Add-In, wenn in Word- und
            'Powerpoint in 'Extras > Makro >Sicherheit > Vertrauenswrdige Quellen'
            'das Kontrollkstchen 'Zugriff auf Visual-Basic-Projekt vertrauen' nicht an ist
                MsgBox fsText(sMSG_POWERPOINTSOURCENICHTLADBAR) _
                    , vbExclamation, sTITEL_MACHEN
                fbPowerpointAddInErzeugen = False
        End If
        
        oPowerpoint.Quit
        Set oPowerpoint = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_POWERPOINT, sOfficeVersion)
        
End Function

Function fbUebersetzungDokumentErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Dim oWord As Object
    'Dim oDokument As Object
    Dim oControl As Object
    Dim iFehlerNummer As Integer
    Dim vEineDatei As Variant
    Dim sDateien(2) As String
    Dim sSourcePfad As String
    Dim bSavePropertiesPromptFlag As Boolean
    
    'Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "EDIT_Prozeduren.bas"
    sDateien(1) = "EDIT_Schnittstellen.bas"
    sDateien(2) = "EDIT_UserForm.frm"
       
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & sSOURCEDIR & vEineDatei, vbNormal) = sLEER Then
                MsgBox fsText(sMSG_SOURCEFEHLT _
                    , gsInstVerzeichnis & sSOURCEDIR & CStr(vEineDatei)) _
                    , vbExclamation, sTITEL_MACHEN
                fbUebersetzungDokumentErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbUebersetzungDokumentErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                False)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_RUNTIME_MIT_TRACE
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & sSOURCEDIR & vEineDatei, _
                gsInstVerzeichnis & sRUNTIMEDIR & vEineDatei, _
                True)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & sRUNTIMEDIR
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & sSOURCEDIR
    End Select
    
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_WORD, sOfficeVersion) = False Then
        fbUebersetzungDokumentErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbUebersetzungDokumentErzeugen = True
    
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox fsText(sMSG_KEINEWEITEREVERBINDUNGZUWORD) _
            , vbExclamation, sTITEL_MACHEN
        fbUebersetzungDokumentErzeugen = False
    End If
    
    If fbUebersetzungDokumentErzeugen = True Then
    
        'Word Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht eingreifen,
        'falls das Erzeugen des Dokuments nicht funktioniert.
        oWord.Visible = True
        oWord.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Dokument leer angelegt
        oWord.Documents.Add
        
        'Status fr die Anzeige der Eigengschaftsfensters merken und zurcksetzen
        bSavePropertiesPromptFlag = oWord.Options.SavePropertiesPrompt
        oWord.Options.SavePropertiesPrompt = False
    
        'Dokument speichern
        oWord.ActiveDocument.SaveAs _
            FileName:=gsInstVerzeichnis & gsUebersetzungDokument
            
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oWord.ActiveDocument.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox fsText(sMSG_WORDSOURCENICHTLADBAR) _
                        , vbExclamation, sTITEL_MACHEN
                    fbUebersetzungDokumentErzeugen = False
                    Exit For
                End If
            End If
        Next vEineDatei
                        
        If fbUebersetzungDokumentErzeugen = True Then
        
            'Add-In noch mal speichern
            'Ohne dieses zustzliche Speichern als Template funktioniert bei Office97 die Prozedur
            'AutoExec im erzeugten Add-In nicht, wenn die unvernderte Source verwendet wird. Wurde
            'die Source zuvor mit fbSourceOhneKommentar_erzeugen verndert, gibt es keine Probleme.
            'Die Source ohne Kommentare unterscheidet sich von der Originalsource durch ihre
            'fehlerhafte Formatierung. Die Einrckungen am Zeilenanfang fehlen.
            '17.8.2002 Es funktioniert doch nicht immer
            oWord.ActiveDocument.SaveAs _
                FileName:=gsInstVerzeichnis & gsUebersetzungDokument
        
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdSaveChanges
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox fsText(sMSG_UEBERSETZUNGDOKUMENTNICHTERZEUGT) _
                    , vbExclamation, sTITEL_MACHEN
                fbUebersetzungDokumentErzeugen = False
            Else
                fbUebersetzungDokumentErzeugen = True
            End If
        Else
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdDoNotSaveChanges
            On Error GoTo 0
        End If
        
        'Status fr die Anzeige der Eigengschaftsfensters wieder auf dem gemerkten Wert setzen
        oWord.Options.SavePropertiesPrompt = bSavePropertiesPromptFlag
        
        oWord.Quit SaveChanges:=wdDoNotSaveChanges
        Set oWord = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_WORD, sOfficeVersion)

End Function

'===================================================================================================
'Funktionen zum Erzeugen der VBA-Sourcen
'===================================================================================================

Function fbSourceOhneKommentar_erzeugen(sDateiNameAlt As String, sDateiNameNeu As String, bTrace As Boolean) As Boolean
    
    Const sKZENDE As String = " _"
    Const lMAXZEILENLAENGE As Long = 1023
    Const sOPTIONEXPLIZIT As String = "Option Explicit"
    
    Dim lPosKommentar As Long
    Dim lPosLiteral As Long
    Dim sFortsetzung As String
    Dim sZeile As String
    Dim sTraceZeile As String
    Dim iDateiAltNr As Integer
    Dim iDateiNeuNr As Integer
    
    If Dir(sDateiNameNeu, vbNormal) <> sLEER Then
        'Ergebnis existiert schon -> fertig
        fbSourceOhneKommentar_erzeugen = True
        Exit Function
    End If
    
    iDateiAltNr = FreeFile
    Open sDateiNameAlt For Input Access Read Shared As #iDateiAltNr
    iDateiNeuNr = FreeFile
    Open sDateiNameNeu For Output Access Write As #iDateiNeuNr
    
    'Print #iDateiNeuNr, "Rem Copyright (C) 2002 J.W.Schmitz-Hbsch"
    'Print #iDateiNeuNr, "Rem Dieser Code wurde aus der Source " & sDateiNameAlt & " generiert."
    
    sFortsetzung = sLEER
    Do While Not EOF(iDateiAltNr) ' Auf Dateiende abfragen.
        Line Input #iDateiAltNr, sZeile   ' Datenzeilen lesen.
        sZeile = sZeile & sLEER
        lPosKommentar = InStr(sZeile, "'")
        lPosLiteral = InStr(sZeile, Chr(34))
        If lPosKommentar > 0 _
        And (lPosLiteral = 0 Or lPosKommentar < lPosLiteral) Then
            sZeile = Left(sZeile, lPosKommentar - 1)
        End If
        'If Left(Trim(sZeile), 4) = "Rem " Then
        '    sZeile = sLEER
        'End If
        If Not Trim(sZeile) = sLEER Then
            sZeile = Trim(sZeile)
            If sZeile = sOPTIONEXPLIZIT Then
                Print #iDateiNeuNr, "Rem Copyright (C) 2002 J.W.Schmitz-Hbsch"
                Print #iDateiNeuNr, "Rem Dieser Code wurde aus der Source " & sDateiNameAlt & " generiert."
            End If
            
            '----------------------+---------+---------+---------+---------+---------+---------+
            '                      |   (1)   |   (2)   |   (3)   |   (4)   |   (5)   |   (6)   |
            '----------------------+---------+---------+---------+---------+---------+---------+
            'sFortsetzung          |  leer   |  leer   | gefllt | gefllt | gefllt | gefllt |
            'sZeile                |fortsetz.| normal  |fortsetz.|fortsetz.| normal  | normal  |
            'sZeile + sForts > 1023|    -    |    -    |    J    |    N    |    J    |    N    |
            '----------------------+---------+---------+---------+---------+---------+---------+
            'sForts.=sForts.&sZeile|    -    |    -    |    -    |    X    |    -    |    X    |
            'Print sFortsetzung    |    -    |    -    |    X    |    -    |    X    |    X    |
            'sFortsetzung = ""     |    -    |    -    |    -    |    -    |    X    |    -    |
            'sFortsetzung = sZeile |    X    |    -    |    X    |    -    |    -    |    -    |
            'Print sZeile          |    -    |    X    |    -    |    -    |    X    |    -    |
            '----------------------+---------+---------+---------+---------+---------+---------+
            If sFortsetzung = sLEER Then
                If Right(sZeile, 2) = sKZENDE Then
                    'Fall (1)
                    sFortsetzung = Trim(Left(sZeile, Len(sZeile) - 2))
                Else
                    'Fall (2)
                    Print #iDateiNeuNr, sZeile
                    If bTrace = True Then
                        sTraceZeile = fsTraceZeileErzeugen(sZeile, lMAXZEILENLAENGE)
                        If sTraceZeile <> sLEER Then
                            Print #iDateiNeuNr, sTraceZeile
                        End If
                    End If
                End If
            Else
                If Right(sZeile, 2) = sKZENDE Then
                    If Len(sFortsetzung & sSPACE & sZeile) > lMAXZEILENLAENGE Then
                        'Fall (3)
                        Print #iDateiNeuNr, sFortsetzung & sKZENDE
                        sFortsetzung = Trim(Left(sZeile, Len(sZeile) - 2))
                    Else
                        'Fall (4)
                        sFortsetzung = sFortsetzung & sSPACE & Trim(Left(sZeile, Len(sZeile) - 2))
                    End If
                Else
                    If Len(sFortsetzung & sSPACE & sZeile) > lMAXZEILENLAENGE Then
                        'Fall (5)
                        Print #iDateiNeuNr, sFortsetzung & sKZENDE
                        Print #iDateiNeuNr, sZeile
                        If bTrace = True Then
                            sTraceZeile = fsTraceZeileErzeugen(sFortsetzung & sSPACE & sZeile _
                                , lMAXZEILENLAENGE)
                            If sTraceZeile <> sLEER Then
                                Print #iDateiNeuNr, sTraceZeile
                            End If
                        End If
                        sFortsetzung = sLEER
                    Else
                        'Fall (6)
                        sFortsetzung = sFortsetzung & sSPACE & Trim(sZeile)
                        Print #iDateiNeuNr, sFortsetzung
                        If bTrace = True Then
                            sTraceZeile = fsTraceZeileErzeugen(sFortsetzung, lMAXZEILENLAENGE)
                            If sTraceZeile <> sLEER Then
                                Print #iDateiNeuNr, sTraceZeile
                            End If
                        End If
                        sFortsetzung = sLEER
                    End If
                End If
            End If
        End If
    Loop
    
    Close #iDateiAltNr
    Close #iDateiNeuNr
    
    'Zu UserForms (.frm) gehrt immer eine .frx-Datei
    If LCase(Right(sDateiNameAlt, 4)) = ".frm" _
    And LCase(Right(sDateiNameNeu, 4)) = ".frm" Then
        Call fbDatei_kopieren( _
            Left(sDateiNameAlt, Len(sDateiNameAlt) - 4) & ".frx", _
            Left(sDateiNameNeu, Len(sDateiNameNeu) - 4) & ".frx")
    End If
    
    fbSourceOhneKommentar_erzeugen = True
    
End Function

Function fsTraceZeileErzeugen(sZeile As String, lMAXZEILENLAENGE As Long) As String
    'Die Funktion gibt den Inhalt zurck, der in als Trace-Zeile ausgegeben werden soll.
    'Wenn diese Funktion in anderen Programmen als Gs4Word eingesetzt werden soll, muss sie noch
    'berarbeitet werden.
    'Argumente:
    '   sZeile = SourceZeile
    '   lMAXZEILENLAENGE = Maximale Zeilenlaenge
    'Rckgabewert:
    '   xxx = Trace-Zeile
    '   sLEER = Keine Trace-Zeile
    'Effekt
    '   Die Datei sDateinameSprachtexte wurde neu erzeugt.
    
    Const sTRACEZEILEAUSGEBEN_NAME As String = "fsTraceZeileAusgeben"
    
    Dim lPosVon As Long
    Dim lPosBis As Long
    Dim sNeueZeile As String
    Dim iAnzahlToken As Integer
    Dim sTokenListe() As String
    Dim iTokenNr As Integer
    Dim sToken1 As String
    Dim sToken2 As String
    Dim lPos As Long
    
    Dim lLaenge As Long
        
    Static bTraceSwitch As Byte 'Default ist sTRACE_AUS
    Const sTRACE_AUS As Byte = 0
    Const sTRACE_AN As Byte = 1
    Const sTRACE_SOLLUNTEBRECHEN As String = 2
    Const sTRACE_ISTUNTERBROCHEN As String = 3
    
    fsTraceZeileErzeugen = sLEER
    
    If Len(sZeile) = 0 _
    Or Left(LTrim(sZeile), 1) = "'" Then
        Exit Function
    End If
        
    'Alle Leerzeichen in Literalen durch Chr(255) ersetzen
    sNeueZeile = Trim(sZeile)
    lPosVon = InStr(1, sNeueZeile, Chr(34)) 'Erstes Vorkommen von " suchen
    If lPosVon > 0 Then
        lPosBis = InStr(lPosVon + 1, sNeueZeile, Chr(34)) 'zweites Vorkommen von " suchen
    End If
    Do While lPosVon > 0 And lPosBis > 0 'Solange suchen kein Literal mehr gefunden wurde
        sNeueZeile = Left(sNeueZeile, lPosVon) _
            & fsErsetzeZeichen(Mid(sNeueZeile, lPosVon, lPosBis - lPosVon), sSPACE, Chr(255)) _
            & Mid(sNeueZeile, lPosBis)
        lPosVon = InStr(lPosBis + 1, sNeueZeile, Chr(34)) 'Erstes Vorkommen von " suchen
        If lPosVon > 0 Then
            lPosBis = InStr(lPosVon + 1, sNeueZeile, Chr(34)) 'zweites Vorkommen von " suchen
        End If
    Loop
      
    sNeueZeile = Trim(fsErsetzeZeichen(sNeueZeile, vbTab, sSPACE))
    sNeueZeile = Trim(fsErsetzeZeichen(sNeueZeile, "(", " ( "))
    sNeueZeile = Trim(fsErsetzeZeichen(sNeueZeile, ")", " ) "))
    sNeueZeile = Trim(fsErsetzeZeichen(sNeueZeile, ",", " , "))
    Do While InStr(sNeueZeile, sSPACE & sSPACE) > 0
        sNeueZeile = Trim(fsErsetzeZeichen(sNeueZeile, sSPACE & sSPACE, sSPACE))
    Loop
    sNeueZeile = sNeueZeile & sSPACE
    iAnzahlToken = fiZaehleZeichen(sNeueZeile, sSPACE)
    If Len(sNeueZeile) = 0 Then
        Exit Function
    End If
    
    ReDim sTokenListe(iAnzahlToken)
    'Tokenliste fllen
    lPosVon = 1
    For iTokenNr = 1 To iAnzahlToken
        lPosBis = InStr(lPosVon, sNeueZeile, sSPACE)
        If lPosBis = 0 Then
            Exit For
        End If
        sTokenListe(iTokenNr) = Trim(Mid(sNeueZeile, lPosVon, lPosBis - lPosVon))
        lPosVon = lPosBis + 1
    Next iTokenNr
            
    'Prfen ob berhaut eine Prozedur aktiv ist
    If iAnzahlToken >= 2 Then
        Select Case LCase(sTokenListe(1)) & sSPACE & LCase(sTokenListe(2))
            Case "option private", "option explicite", "option compare", "option base" _
            , "end sub", "end function", "end property"
                'Keine Prozedur aktiv
                bTraceSwitch = sTRACE_AUS
                Exit Function
            Case "rem traceoff"
                'Rem TraceOff unterbricht die Ausgabe des Trace bis zur Zeile Rem TraceOn
                'bzw. bis zum Ende der Funktion oder Subroutine
                If bTraceSwitch <> sTRACE_AUS Then
                    'Die Ausgabe wird unterbrochen
                    bTraceSwitch = sTRACE_SOLLUNTEBRECHEN
                End If
            Case "rem traceon"
                If bTraceSwitch <> sTRACE_AUS Then
                    'Die Ausgabe wird wieder aktiviert
                    bTraceSwitch = sTRACE_AN
                End If
        End Select
        If LCase(sTokenListe(2)) <> "function" _
        And LCase(sTokenListe(2)) <> "sub" _
        And LCase(sTokenListe(2)) <> "property" Then
            Select Case LCase(sTokenListe(1))
                Case "declare", "private", "public", "type"
                    'Keine Prozedur aktiv
                    bTraceSwitch = sTRACE_AUS
                    Exit Function
            End Select
        End If
    End If
    
    'Function oder Sub verarbeiten
    iTokenNr = 0
    Select Case LCase(sTokenListe(1))
        Case "function", "sub"
            'Function xxx ( )
            'Function xxx ( xxx )
            'Function xxx ( xxx as string )
            If sTokenListe(3) = "(" _
            And iAnzahlToken >= 4 Then
                iTokenNr = 4
            End If
        Case "property"
            'Property get xxx ( )
            'Function let xxx ( xxx )
            'Function set xxx ( xxx as string )
            If sTokenListe(4) = "(" _
            And iAnzahlToken >= 5 Then
                iTokenNr = 5
            End If
        Case "public", "private", "static"
            'Public Function xxx ( )
            'Public Function xxx ( xxx )
            'Public Function xxx ( xxx as string )
            Select Case LCase(sTokenListe(2))
                Case "function", "sub"
                    If sTokenListe(4) = "(" _
                    And iAnzahlToken >= 5 Then
                        iTokenNr = 5
                    End If
                Case "property"
                    'Public Property get xxx ( )
                    'Public Function let xxx ( xxx )
                    'Public Function set xxx ( xxx as string )
                    If sTokenListe(5) = "(" _
                    And iAnzahlToken >= 6 Then
                        iTokenNr = 6
                    End If
            End Select
    End Select
    If iTokenNr > 0 Then
        'Function oder Sub gefunden
        If LCase(sTokenListe(iTokenNr - 2)) = LCase(sTRACEZEILEAUSGEBEN_NAME) Then
            bTraceSwitch = sTRACE_AUS
            Exit Function
        End If
        bTraceSwitch = sTRACE_AN
        For iTokenNr = iTokenNr To iAnzahlToken
            Select Case LCase(sTokenListe(iTokenNr))
                Case "optional", "paramarray", ")", "("
                    Exit For
                Case "byval", "byref", "as", ","
                Case Else
                    '"xxx=" & xxx & vbcr & "yyy="yyy"
                    If sTokenListe(iTokenNr) <> "," _
                    And LCase(sTokenListe(iTokenNr - 1)) <> "as" Then
                        fsTraceZeileErzeugen = fsTraceZeileErzeugen & " & vbNewline & " _
                            & "vbTab & " & Chr(34) & sTokenListe(iTokenNr) & "=" & Chr(34) _
                            & " & Chr(34) & " & sTokenListe(iTokenNr) & " & Chr(34)"
                   End If
            End Select
        Next iTokenNr
    End If
    
    'Je nach bTraceSwitch fertig oder Weiter
    Select Case bTraceSwitch
        Case sTRACE_AUS, sTRACE_ISTUNTERBROCHEN
            'Wenn keine Prozedur aktiv ist, dann ist jetzt Schluss
            Exit Function
        Case sTRACE_SOLLUNTEBRECHEN
            bTraceSwitch = sTRACE_ISTUNTERBROCHEN
    End Select
    'Ab hier darf bTraceSwitch nicht mehr verndert werden
    
    'Dim und Const verarbeiten
    'If iTokenNr = 0 Then
    '    Select Case LCase(sTokenListe(1))
    '        Case "dim", "const"
    '            Exit Function
    '    End Select
    'End If
    
    'Select Case verarbeiten
    If iTokenNr = 0 _
    And iAnzahlToken >= 2 Then
        If LCase(sTokenListe(1)) = "select" _
        And LCase(sTokenListe(2)) = "case" Then
            'zwischen den Zeilen "Select case ..." und "Case ..." darf keine Zeile eingefgt werden
            Exit Function
        End If
    End If
    
    'For und Let verarbeiten
    If iTokenNr = 0 _
    And iAnzahlToken >= 3 Then
        If LCase(sTokenListe(1)) = "for" _
        And sTokenListe(3) = "=" Then
            iTokenNr = 2
        ElseIf LCase(sTokenListe(1)) = "let" _
        And sTokenListe(3) = "=" Then
            iTokenNr = 2
        ElseIf sTokenListe(2) = "=" Then
            iTokenNr = 1
        ElseIf LCase(sTokenListe(1)) = "static" _
        And LCase(sTokenListe(3)) = "as" Then
            iTokenNr = 2
        End If
        If iTokenNr > 0 Then
            'Let gefunden
            'Prfen, ob das Ergebnis eine Tabelle ist:
            'GetAllSettings verwendet eine Tabelle
            If iAnzahlToken >= iTokenNr + 2 Then
                If LCase(sTokenListe(iTokenNr + 2)) = "getallsettings" Then
                    iTokenNr = 0
                End If
            End If
            'Prfen, ob das Ergebnis ein Objekt o.. ist
            'Dann enthlt es einen Punkt
            lPos = InStr(sTokenListe(iTokenNr), ".")
            If lPos > 0 Then
                iTokenNr = 0
            End If
            If iTokenNr > 0 Then
                'anzeigbares Let gefunden
                fsTraceZeileErzeugen = fsTraceZeileErzeugen & " & vbNewline & " _
                    & "vbTab & " & Chr(34) & sTokenListe(iTokenNr) & "=" & Chr(34) _
                    & " & Chr(34) & " & sTokenListe(iTokenNr) & " & Chr(34)"
            End If
        End If
    End If
        
    'Alle Anfhrungszeichen " durch ' ersetzen und Trace-Text erzeugen
    sZeile = fsErsetzeZeichen(sZeile, Chr(34), "'")
    'Alle Chr(255) wieder durch Leerzeichen ersetzen
    fsTraceZeileErzeugen = fsErsetzeZeichen(fsTraceZeileErzeugen, Chr(255), sSPACE)
    'Inhalt von fsTraceZeileErzeugen zusammenfgen
    If Len(sZeile & fsTraceZeileErzeugen) <= lMAXZEILENLAENGE - 30 Then
        fsTraceZeileErzeugen = Chr(34) & sZeile & Chr(34) & fsTraceZeileErzeugen
    ElseIf Len(fsTraceZeileErzeugen) <= lMAXZEILENLAENGE - 30 - 30 Then
        lLaenge = lMAXZEILENLAENGE - 30 - Len(fsTraceZeileErzeugen)
        fsTraceZeileErzeugen = Chr(34) & Left(sZeile, lLaenge) & " ..." & Chr(34) _
            & fsTraceZeileErzeugen
    Else
        lLaenge = lMAXZEILENLAENGE - 30
        fsTraceZeileErzeugen = Chr(34) & Left(sZeile, lLaenge) & " ..." & Chr(34)
    End If
    'Trace-Zeile fr die Source erzeugen
    fsTraceZeileErzeugen = sTRACEZEILEAUSGEBEN_NAME & "(" & fsTraceZeileErzeugen & ")"
    
End Function

'===================================================================================================
'Funktionen zum Erzeugen der Sprachsourcen
'===================================================================================================
Function fbSprachsourcenErzeugen(bAktion As Byte, sSprachcode As String) 'As Boolean
    'Die Funktion erzeugt fr alle Sprachen die Sourcen *_Texte.bas neu.
    'Das Programm ist zur Zeit nur fr deutsch, englisch und eine weitere sprache xx ausgelegt.
    'Ansatzweise (Tabellen etc.) ist der Ausbau auf weitere Sprachen schon bercksichtigt.
    'Folgende Dateien werden verwendet:
    '   Sourcen\Texte_xx.txt enthlt die genderten Texte, die in die Sprache xx bersetzt wurden.
    '   Sourcen\XXXX_Texte.bas ist eine Source mit Texten. Sie wird in fbSprachtexte_ermitteln bis
    '       zur ersten Funktion oder Prozedur gelesen und dabei um fehlende englische bersetzungen
    '       ergnzt. Dann wird eine Funktion zum Laden der Texte ergnzt. Alles wird nach
    '       Runtime\XXXX_Texte.bas geschrieben und von dort berkopiert.
    '   Runtime\XXXX_Texte.bas wird erzeugt
    '   Runtime\XXXX_Texte_ger.bas wird erzeugt
    '   Runtime\XXXX_Texte_eng.bas wird erzeugt
    '   Runtime\XXXX_Texte_vba.bas wird erzeugt
    '
    'Global:
    '   gsSprachtexte wird gelesen
    'Argumente:
    '   bAktion ist eine der folgenden Aktion:
    '       bERZEUGE_PRUEFEN
    '       bERZEUGE_AUS_RUNTIME
    '       bERZEUGE_AUS_RUNTIME_MIT_TRACE
    '       bERZEUGE_AUS_SOURCE
    '   sSprachcode = Sprache fr die die Texte erzeugt werden sollen
    '       sLEER = Multisprachversion von der Basissprache aus gsSprachtexte(0, 0)
    '       sSPRACHCODE_DEUTSCH
    '       sSPRACHCODE_ENGLISCH
    '       sSPRACHCODE_WEITERESPRACHE
    'Rckgabewert:
    '   True = Sprachsource erzeugt
    'Effekt
    '   sDateinameSprachsource wirde berschrieben.
    '   Das Verzeichnis Runtime wird leer gemacht und ggf. neu gefllt.

    Const sVBNAME_SUFFIX As String = "Texte"
    Const sTEXTE_SUFFIX As String = "Texte.bas"
    Const sFUNKTIONSNAME1 As String = "fb(&1)SprachtexteErzeugen"
    Const sNAMENSECTION As String = "[(&1)Namen]"
    Const sTEXTESECTION As String = "[(&1)Texte]"
    
    Dim sNamen(7) As String
    Dim vEinName As Variant
    Dim sRunTexteDateinameMuster As String
    Dim sSavTexteDateinameMuster As String
    Dim sKonfTexteDateinameMuster As String
    Dim sUebersetzteTexteDateinameMuster As String
    Dim sSavUebersetzteTexteDateinameMuster As String
    Dim sSprachTexteDatei As String
    Dim sRunSprachTexteDatei As String
    Dim sSavSprachTexteDatei As String
    Dim sRunTexteDateiname As String
    Dim sSavTexteDateiname As String
    Dim sKonfTexteDateiname As String
    Dim sUebersetzteTexteDateiname As String
    Dim sSavUebersetzteTexteDateiname As String
    Dim bStatus As Boolean
    Dim sEineSprache As String
    Dim lSprachNr As Long
    Dim sTimestamp As String
    Dim sDatei As String

    '(1) Namen aller Sourcen des Add-In eintragen
    sNamen(0) = "GLOB_"
    sNamen(1) = "DOC_"
    sNamen(2) = "XLS_"
    sNamen(3) = "PPT_"
    sNamen(4) = "KONF_"
    sNamen(5) = "TECH_"
    sNamen(6) = "INST_"
    sNamen(7) = "MACH_"
        
    fbSprachsourcenErzeugen = False
    
    'Initialisierung der Sprachen in der Sprachtabelle gsSprachtexte
    ReDim Preserve gsSprachtexte(lANZAHL_SPRACHEN, 0)
    gsSprachtexte(0, 0) = sDEFAULT_SPRACHSWITCH 'Default-Sprache
    gsSprachtexte(1, 0) = sSPRACHCODE_DEUTSCH
    gsSprachtexte(2, 0) = sSPRACHCODE_ENGLISCH
    gsSprachtexte(3, 0) = sSPRACHCODE_WEITERESPRACHE
    
    sRunTexteDateinameMuster = gsInstVerzeichnis & sRUNTIMEDIR & "(&1)" & sTXT
    sSavTexteDateinameMuster = gsInstVerzeichnis & sSAVDIR & "(&1)" & sTXT
    sKonfTexteDateinameMuster = gsInstVerzeichnis & sKONFIGDIR & "(&1)" & sTXT
    sUebersetzteTexteDateinameMuster = gsInstVerzeichnis & sSOURCEDIR & "Texte_(&1)" & sTXT
    sSavUebersetzteTexteDateinameMuster = gsInstVerzeichnis & sSAVDIR & "Texte_(&1)" & sTXT
    sTimestamp = Format(Now, "_yyyymmDd_hhnnss")
    
    'Tabelle mit den neuen bersetzungen fllen
    If fbUebersetzungen_lesen(sUebersetzteTexteDateinameMuster) = False Then
        Exit Function
    End If
            
    'Alle Dateien in Runtime lschen
    sDatei = Dir(gsInstVerzeichnis & sRUNTIMEDIR & "*.*", vbNormal)
    Do While sDatei <> ""
        If fbDatei_loeschen(gsInstVerzeichnis & sRUNTIMEDIR & sDatei) = False Then
            Exit Function
        End If
        sDatei = Dir(gsInstVerzeichnis & sRUNTIMEDIR & CStr(vEinName) & "*.*", vbNormal)
        'sDatei = Dir 'reicht hier nicht, denn in fbDatei_loeschen wurde Dir verndert
    Loop
    
    For Each vEinName In sNamen
        'Eine Sprachtexte-Source bearbeiten
        sSprachTexteDatei = gsInstVerzeichnis & sSOURCEDIR & CStr(vEinName) & sTEXTE_SUFFIX
        If Dir(sSprachTexteDatei, vbNormal) = sLEER Then
            MsgBox fsText(sMSG_SOURCEFEHLT _
                , sSprachTexteDatei) _
                , vbExclamation, sTITEL_MACHEN
            Exit Function
        End If
        'Neue Sprachtexte in Runtime erzeugen
        'Der zweite Parameter macht aus XXXX_ einfach "XXXX.
        sRunSprachTexteDatei = gsInstVerzeichnis & sRUNTIMEDIR & CStr(vEinName) & sTEXTE_SUFFIX
        If fbSprachtexte_ermitteln _
        (sSprachTexteDatei _
        , sRunSprachTexteDatei _
        , sRunTexteDateinameMuster _
        , Left(CStr(vEinName), Len(CStr(vEinName)) - 1) & "." _
        , fsText(sFUNKTIONSNAME1, CStr(vEinName)) _
        , fsText(sTEXTESECTION, CStr(vEinName)) _
        , "'" & Mid(sTimestamp, 2) & "'" _
        ) = False Then
            Exit Function
        End If
        ' Den Rest nur beim bERZEUGE_AUS_RUNTIME, bERZEUGE_AUS_RUNTIME_MIT_TRACE und bei
        ' bERZEUGE_AUS_SOURCE machen
        If bAktion = bERZEUGE_AUS_RUNTIME _
        Or bAktion = bERZEUGE_AUS_RUNTIME_MIT_TRACE _
        Or bAktion = bERZEUGE_AUS_SOURCE Then
        
            'Sprachtexte XXXX_Texte.bas sichern und kopieren
            'Alte Sprachtexte in _sav sichern
            sSavSprachTexteDatei = gsInstVerzeichnis & sSAVDIR & CStr(vEinName) & sTEXTE_SUFFIX _
                & sTimestamp
            If fbDatei_kopieren(sSprachTexteDatei, sSavSprachTexteDatei) = False Then
                Exit Function
            End If
            'Neue Sprachtexte aus Runtime nach Sourcen kopieren und in Runtime lschen
            If fbDatei_kopieren(sRunSprachTexteDatei, sSprachTexteDatei) = False Then
                Exit Function
            End If
            If fbDatei_loeschen(sRunSprachTexteDatei) = False Then
                Exit Function
            End If
            
            'Damit ist die Source fr eine Multisprachversion fertig:
            '   - Die Sprachtexte sind vorhanden
            '   - Fall das Add-In aus der Source erzeugt werden soll, ist die erweiterte Source
            '       vorhanden.
            '   - Falls das Add-In aus Runtime erzeugt werden soll, ist die Source dort noch nicht
            '       vorhanden und wird dort von fbSourceOhneKommentar_erzeugen neu erzeugt.
            'Wenn die Source fr eine einzelne Sprache erzeugt werden soll, muss das jetzt noch
            'erfolgen.
            For lSprachNr = 1 To UBound(gsSprachtexte, 1)
                sEineSprache = gsSprachtexte(lSprachNr, 0)
                If sEineSprache <> sLEER _
                And sSprachcode = sEineSprache Then
                    'Jetzt nur die erforderliche Sprachdatei erzeugen
                    If fbEineSprachSource_erzeugen _
                    (sSprachTexteDatei _
                    , sRunSprachTexteDatei _
                    , CStr(vEinName) & sVBNAME_SUFFIX, sEineSprache _
                    , fsText(sFUNKTIONSNAME1, CStr(vEinName)) _
                    ) = False Then
                        Exit Function
                    End If
                End If
            Next lSprachNr
        Else
            'bAktion ist = bERZEUGE_PRUEFEN, deshalb neue Sprachtexte in Runtime lschen
            If fbDatei_loeschen(sRunSprachTexteDatei) = False Then
                Exit Function
            End If
        
        End If
    Next vEinName
    
    If bAktion = bERZEUGE_AUS_RUNTIME _
    Or bAktion = bERZEUGE_AUS_RUNTIME_MIT_TRACE _
    Or bAktion = bERZEUGE_AUS_SOURCE Then
        For lSprachNr = 1 To UBound(gsSprachtexte, 1)
            'Sprachtexte xx.txt sichern und kopieren
            sRunTexteDateiname = fsText(sRunTexteDateinameMuster, gsSprachtexte(lSprachNr, 0))
            sSavTexteDateiname = fsText(sSavTexteDateinameMuster, gsSprachtexte(lSprachNr, 0) & sTimestamp)
            sKonfTexteDateiname = fsText(sKonfTexteDateinameMuster, gsSprachtexte(lSprachNr, 0))
            'Alte Sprachtexte in _sav sichern
            If fbDatei_kopieren(sKonfTexteDateiname, sSavTexteDateiname) = False Then
                Exit Function
            End If
            'Neue Sprachtexte aus Runtime nach Installationsverzeichnis kopieren und in Runtime lschen
            If fbDatei_kopieren(sRunTexteDateiname, sKonfTexteDateiname) = False Then
                Exit Function
            End If
            If fbDatei_loeschen(sRunTexteDateiname) = False Then
                Exit Function
            End If
            'bersetzungen Texte_xx.txt sichern und lschen
            sUebersetzteTexteDateiname = fsText(sUebersetzteTexteDateinameMuster, _
                gsSprachtexte(lSprachNr, 0))
            sSavUebersetzteTexteDateiname = fsText(sSavUebersetzteTexteDateinameMuster, _
                gsSprachtexte(lSprachNr, 0) & sTimestamp)
            If Dir(sUebersetzteTexteDateiname, vbNormal) <> sLEER Then
                If fbDatei_kopieren(sUebersetzteTexteDateiname, _
                sSavUebersetzteTexteDateiname) = False Then
                    Exit Function
                End If
                If fbDatei_loeschen(sUebersetzteTexteDateiname) = False Then
                    Exit Function
                End If
            End If
        Next lSprachNr
        'Sprachtexte vba.txt sichern und kopieren
        sRunTexteDateiname = fsText(sRunTexteDateinameMuster, "vba")
        sSavTexteDateiname = fsText(sSavTexteDateinameMuster, "vba" & sTimestamp)
        sKonfTexteDateiname = fsText(sKonfTexteDateinameMuster, "vba")
        'Alte Sprachtexte in _sav sichern
        If fbDatei_kopieren(sKonfTexteDateiname, sSavTexteDateiname) = False Then
            Exit Function
        End If
        'Neue Sprachtexte aus Runtime nach Installationsverzeichnis kopieren und in Runtime lschen
        If fbDatei_kopieren(sRunTexteDateiname, sKonfTexteDateiname) = False Then
            Exit Function
        End If
        If fbDatei_loeschen(sRunTexteDateiname) = False Then
            Exit Function
        End If
    End If
    
    fbSprachsourcenErzeugen = True
    
End Function

Function fbUebersetzungen_lesen(sUebersetzteTexteDateinameMuster As String) As Boolean
    'Die Funktion liest im Verzeichnis sVerzeichnis alle vorhandenen Sprachdateien mit den neuen
    'bersetzungen ud und schreibt sie strukturiert in die Tabelle gsUebersetzungen
    'Zu jeder bersetzung ist eine Sprachdatei erforderlich
    '   Sourcen\Texte_xx.txt enthlt die genderten Texte, die in die Sprache xx bersetzt wurden.
    'Jede Zeile muss aus dem VBA-Namen (ohne Leerzeichen, einem Leerzeichen und dem Text in Anfhrungszeichen bestehen.
    'Ansonsten wird die Zeile ignoriert.
    'Global:
    '   gsSprachtexte wird gelesen
    '   gsUebersetzungen wird neu aufgebaut
    'Argumente:
    '   sUebersetzteTexteDateinameMuster = Muster fr die Dateien Texte_xx.txt
    'Rckgabewert:
    '   true = gsUebersetzungen ist leer oder wurde gefllt.
    'Effekt
    '   keiner

    Dim lSprachNr As Long
    Dim sUebersetzteTexteDateiname As String
    Dim sUebTexteDatei As String
    Dim lUebZaehler As Long
    Dim sZeile As String
    Dim lPos As Long
    Dim iTexteDateiNummer As Integer
    
    lUebZaehler = 0
    For lSprachNr = 1 To UBound(gsSprachtexte, 1)
        sUebersetzteTexteDateiname = fsText(sUebersetzteTexteDateinameMuster, _
            gsSprachtexte(lSprachNr, 0))
        If Dir(sUebersetzteTexteDateiname, vbNormal) <> sLEER Then
            iTexteDateiNummer = FreeFile
            Open sUebersetzteTexteDateiname For Input Access Read Shared As #iTexteDateiNummer
            Do While Not EOF(iTexteDateiNummer) ' Auf Dateiende abfragen.
                Line Input #iTexteDateiNummer, sZeile
                lUebZaehler = lUebZaehler + 1
            Loop
            Close #iTexteDateiNummer
        End If
    Next lSprachNr
    
    ReDim Preserve gsUebersetzungen(2, lUebZaehler)
    If lUebZaehler = 0 Then
        fbUebersetzungen_lesen = True
        Exit Function
    End If
    
    'gsUebersetzungen(n,0) ist unbenutzt
    'gsUebersetzungen(0,n) ist die Nummer der Sprache, in die bersetzt wird
    'gsUebersetzungen(1,n) ist der Vba-Name des Textes
    'gsUebersetzungen(2,n) ist der bersetzte Text
       
    lUebZaehler = 0
    For lSprachNr = 1 To UBound(gsSprachtexte, 1)
        sUebersetzteTexteDateiname = fsText(sUebersetzteTexteDateinameMuster, _
            gsSprachtexte(lSprachNr, 0))
        If Dir(sUebersetzteTexteDateiname, vbNormal) <> sLEER Then
            iTexteDateiNummer = FreeFile
            Open sUebersetzteTexteDateiname For Input Access Read Shared As #iTexteDateiNummer
            Do While Not EOF(iTexteDateiNummer) ' Auf Dateiende abfragen.
                lUebZaehler = lUebZaehler + 1
                gsUebersetzungen(0, lUebZaehler) = lSprachNr
                Line Input #iTexteDateiNummer, sZeile
                lPos = InStr(sZeile, "=")
                If lPos > 1 _
                And Mid(sZeile, lPos + 1, 1) = Chr(34) _
                And Right(Trim(sZeile), 1) = Chr(34) Then
                   gsUebersetzungen(1, lUebZaehler) = Left(sZeile, lPos - 1)
                   gsUebersetzungen(2, lUebZaehler) = Mid(sZeile, lPos + 1)
                End If
            Loop
            Close #iTexteDateiNummer
        End If
    Next lSprachNr
    
    fbUebersetzungen_lesen = True

End Function

Function fbSprachtexte_ermitteln(sDateinameSprachtexte As String, _
sDateinameTmpSprachtexte As String, sRunTexteDateinameMuster As String, sPraefixName As String, _
sFunktion1_Name As String, sTexteSection_Name As String, sTimestamp As String) As Boolean
    'Die Funktion liest die Sprachtexte aus sDateinameSprachtexte und schreibt sie strukturiert in
    'die Tabelle gsSprachtexte.
    'Sie schreibt danach jede Zeile in die Datei sDateinameTmpSprachtexte und ergnzt fehlende
    'bersetzungen. Danach schreibt sie eine Funktion mit den Namen aus sFunktionsname und der
    'Spache als Parameter in diese Datei. Das Ergebnis dieser Funktion ist True

    ' Jeder Sprachtext hat folgenden Aufbau:
    '   Public XXXXXX As String
    '   Rem de "deutscher Text"
    '   Rem en "englischer Text"
    '   Rem xx "Text in der sprache xx"
    'Falls eine Sprache fehlt, wird dafr "XXXXXX" eingesetzt
    'Die Sprachtexte enden bei
    '   - Dateiende
    '   - der ersten Prozedur
    '   - der ersten Funktion
    'Global:
    '   gsSprachtexte wird neu aufgebaut
    '   gsUebersetzungen wird gelesen
    'Argumente:
    '   sDateinameSprachtexte = Dateiname der Basic-Source mit Sprachtexten
    '   sDateinameTmpSprachtexte = Dateiname fr eine temporaere Datei mit Sprachtexten
    '   sRunTexteDateinameMuster = Muster fr den Namen der Sprachtexte-Datei xx.txt mit Pfad
    '   sPraefix_Name = Name des Moduls in der Form XXX.
    '   sFunktion1_Name = Name der Funktion zum Erzeugen der Sprachtexte
    '   sTexteSection_Name = Name der Textesection
    '   sTimeStamp = Timestamp fr genderte, alte Texte in der Form 'jjjjmmtt_hhmmss'
    'Rckgabewert:
    '   True = Es werden nur fehlerfreie Texte gefunden
    '   False = es wurden keine oder auch fehlerhafte Texte gefunden
    'Effekt
    '   Die Datei sDateinameSprachtexte wurde neu erzeugt.
    
    Dim sZeile As String
    Dim sZeile1 As String
    Dim sToken1 As String
    Dim lPosAnfang As Long
    Dim lPosEnde As Long
    Dim lZaehler As Long
    Dim lUebZaehler As Long
    Dim lFehlZaehler As Long
    Dim lSprachNr As Long
    Dim sVarname As String
    Dim sSprachcode As String
    Dim sText As String
    Dim sTextInBasissprache As String
    Dim sRunTexteDateiname As String
    Dim lAnzahlZeilen As Long
    Dim iSprachtexteDateinummer As Integer
    Dim iTmpSprachtexteDateinummer As Integer
    Dim iRunTexteDateinummer As Integer
    Dim sSprachtextfehler()
    'sSprachtextfehler(0,n) ist der Fehlertext fr den Variablen/Konstantenname
    'sSprachtextfehler(1,n) ist der Fehlertext in der ersten Sprache
    'sSprachtextfehler(2,n) ist der Fehlertext in der zweiten Sprache
    'sSprachtextfehler(3,n) ist der Fehlertext in der dritten Sprache
    'sSprachtextfehler(n,n) ist der Fehlertext in der n-ten Sprache
    
    'Die Namen und die Reihenfolge der Sprachen in gsSprachtexte(n, 0) ist schon gefllt
    ReDim Preserve gsSprachtexte(lANZAHL_SPRACHEN, 0)
    'gsSprachtexte(0,0) ist der Name der Basissprache, fr die alle Texte vorhanden sein mssen
    'gsSprachtexte(1,0) ist der Name der ersten Sprache
    'gsSprachtexte(2,0) ist der Name der zweiten Sprache
    'gsSprachtexte(3,0) ist der Name der dritten Sprache
    'gsSprachtexte(n,0) ist der Name der n-ten Sprache
    'gsSprachtexte(0,n) ist der Variablen/Konstantenname
    'gsSprachtexte(1,n) ist der Text in der ersten Sprache
    'gsSprachtexte(2,n) ist der Text in der zweiten Sprache
    'gsSprachtexte(3,n) ist der Text in der dritten Sprache
    'gsSprachtexte(n,n) ist der Text in der n-ten Sprache
        
    iSprachtexteDateinummer = FreeFile
    Open sDateinameSprachtexte For Input Access Read Shared As #iSprachtexteDateinummer
    iTmpSprachtexteDateinummer = FreeFile
    Open sDateinameTmpSprachtexte For Output Access Write As #iTmpSprachtexteDateinummer

    lZaehler = 0
    Do While Not EOF(iSprachtexteDateinummer) ' Auf Dateiende abfragen.
        Line Input #iSprachtexteDateinummer, sZeile  ' Datenzeilen lesen.
        sZeile1 = Trim(sZeile) & sSPACE
        sToken1 = Trim(LCase(Left(sZeile1, InStr(sZeile1, sSPACE)))) 'Erstes Wort der Zeile ermitteln
        'Zeile analysieren
        Select Case sToken1
            Case "public"
                sZeile1 = Trim(sZeile) & sSPACE
                lPosAnfang = 8
                lPosEnde = InStr(lPosAnfang, sZeile1, sSPACE)
                If lPosEnde > 0 _
                And lPosEnde > lPosAnfang _
                And LCase(Mid(sZeile1, lPosEnde, 10)) = " as string" Then
                    sVarname = Mid(sZeile1, lPosAnfang, lPosEnde - lPosAnfang)
                    sTextInBasissprache = sLEER
                    'Hier beginnt eine neue Deklaration
                    If sVarname <> sLEER Then
                        lZaehler = lZaehler + 1
                        If UBound(gsSprachtexte, 2) < lZaehler Then
                            ReDim Preserve sSprachtextfehler(lANZAHL_SPRACHEN, lZaehler + 100)
                            ReDim Preserve gsSprachtexte(lANZAHL_SPRACHEN, lZaehler + 100)
                        End If
                        gsSprachtexte(0, lZaehler) = sVarname
                        ' Fr alle Sprachen profylaktisch Fehler "Keine "Rem Zeile" eintragen
                        For lSprachNr = 1 To UBound(gsSprachtexte, 1)
                            sSprachtextfehler(lSprachNr, lZaehler) = "Fehler#11: " _
                                & gsSprachtexte(lSprachNr, 0)
                        Next lSprachNr
                    Else
                        'Fehlerhafte Variable
                        sSprachtextfehler(0, lZaehler) = "Fehler#01: " & sZeile
                    End If
                Else
                    sSprachtextfehler(0, lZaehler) = "Fehler#02: " & sZeile
                End If
            Case "rem"
                sZeile1 = Trim(sZeile)
                lPosAnfang = 5
                lPosEnde = InStr(lPosAnfang, sZeile1 & sSPACE, sSPACE)
                If lPosEnde > 0 _
                And lPosEnde > lPosAnfang Then
                    'Es ist eine Rem-Zeile mit einem Sprachcode
                    sSprachcode = Mid(sZeile1, lPosAnfang, lPosEnde - lPosAnfang)
                    'Jetzt alle Sprachen durchnudeln und nur die passende Sprache bearbeiten
                    For lSprachNr = 1 To UBound(gsSprachtexte, 1)
                        If LCase(gsSprachtexte(lSprachNr, 0)) = LCase(sSprachcode) Then
                            'Sprache passt; jetzt verarbeiten
                            'Fehlermeldung zurcksetzen
                            sSprachtextfehler(lSprachNr, lZaehler) = sLEER
                            If gsSprachtexte(lSprachNr, lZaehler) = sLEER Then
                                'Es ist die erste Rem-Zeile fr diese Sprache
                                'Jetzt prfen, was mit dem Text in der Zeile ist
                                If Mid(sZeile1, lPosEnde + 1, 1) = Chr(34) _
                                And Right(sZeile1, 1) = Chr(34) Then
                                    'Die Rem-Zeile enthlt einen gltigen Text
                                    sText = Mid(sZeile1, lPosEnde + 1)
                                    gsSprachtexte(lSprachNr, lZaehler) = sText
                                    If LCase(gsSprachtexte(0, 0)) = LCase(sSprachcode) Then
                                        'Es ist die Basissprache
                                        sTextInBasissprache = sText
                                    End If
                                ElseIf sSprachcode = gsSprachtexte(0, 0) Then
                                    'Kein Text oder fehlerhafter Text in der Sprache, fr die alle
                                    'Texte vorhanden sein mssen
                                    sSprachtextfehler(lSprachNr, lZaehler) = "Fehler#12: " & sZeile
                                ElseIf Trim(Mid(sZeile1, lPosEnde + 1)) = sLEER _
                                And sTextInBasissprache <> sLEER Then
                                    'Kein Sprachtext vorhanden
                                    'tue nichts
                                    'sZeile = "Rem " & sSPACE & sSprachcode & sSPACE & Chr(34) & Chr(34)
                                Else
                                    'Fehler, denn die Rem-Zeile enthlt keinen gltigen Text
                                    sSprachtextfehler(lSprachNr, lZaehler) = "Fehler#13: " & sZeile
                                End If
                            Else
                                'Fehler, denn es ist nicht die erste Rem-Zeile fr diese Sprache
                                sSprachtextfehler(lSprachNr, lZaehler) = "Fehler#14: " & sZeile
                            End If
                            'Prfen ob zum VBA-Text eine neue bersetzung vorhanden ist.
                            For lUebZaehler = 1 To UBound(gsUebersetzungen, 2)
                                If gsUebersetzungen(0, lUebZaehler) = CStr(lSprachNr) _
                                And LCase(gsUebersetzungen(1, lUebZaehler)) _
                                = LCase(sPraefixName & sVarname) Then
                                    'Neue Uebersetzung gefunden
                                    'Diese bersetzung merken
                                    gsSprachtexte(lSprachNr, lZaehler) _
                                        = gsUebersetzungen(2, lUebZaehler)
                                    'Alte Zeile als Kommentar ausgeben
                                    If Len(sZeile) > 9 Then 'REM xx ""'
                                        Print #iTmpSprachtexteDateinummer, sTimestamp; sSPACE; sZeile
                                    End If
                                    'Rem-Zeile neu aufbauen
                                    sZeile = "Rem" & sSPACE & sSprachcode & sSPACE _
                                        & gsSprachtexte(lSprachNr, lZaehler)
                                    Exit For
                                End If
                            Next lUebZaehler
                            Exit For
                        End If
                    Next lSprachNr
                    
                 End If
            Case "function", "sub"
                'Fertig
                Exit Do
        End Select
        Print #iTmpSprachtexteDateinummer, sZeile
    Loop
    Close #iSprachtexteDateinummer
    
    'Unbenutzte Elemente in gsSprachtexte entfernen
    ReDim Preserve gsSprachtexte(lANZAHL_SPRACHEN, lZaehler)
    
    'Position in den Dateien fr Sprachtexte ermitteln
    sRunTexteDateiname = fsText(sRunTexteDateinameMuster, "vba")
    lAnzahlZeilen = 0
    If Dir(sRunTexteDateiname, vbNormal) <> sLEER Then
        iRunTexteDateinummer = FreeFile
        Open sRunTexteDateiname For Input Access Read Shared As #iRunTexteDateinummer
        Do While Not EOF(iRunTexteDateinummer)
            Line Input #iRunTexteDateinummer, sZeile
            lAnzahlZeilen = lAnzahlZeilen + 1
        Loop
        Close #iRunTexteDateinummer
    End If
    
    'Dann fr alle Sprachen die Texte an die Dateien fr Sprachtexte anhngen
    iRunTexteDateinummer = FreeFile
    Open sRunTexteDateiname For Append Access Write As #iRunTexteDateinummer
    For lZaehler = 1 To UBound(gsSprachtexte, 2)
        Print #iRunTexteDateinummer, sPraefixName & gsSprachtexte(0, lZaehler)
    Next lZaehler
    Close #iRunTexteDateinummer
    For lSprachNr = 1 To UBound(gsSprachtexte, 1)
        sRunTexteDateiname = fsText(sRunTexteDateinameMuster, gsSprachtexte(lSprachNr, 0))
        iRunTexteDateinummer = FreeFile
        Open sRunTexteDateiname For Append Access Write As #iRunTexteDateinummer
        For lZaehler = 1 To UBound(gsSprachtexte, 2)
            sText = Trim(gsSprachtexte(lSprachNr, lZaehler))
            If Len(sText) > 1 Then
                sText = Mid(sText, 2, Len(sText) - 2)
            End If
            If Len(sText) = 0 _
            Or sText = Chr(34) & Chr(34) Then
                sText = "<" & CStr(lAnzahlZeilen + lZaehler) & ">"
            End If
            Print #iRunTexteDateinummer, sText
        Next lZaehler
        Close #iRunTexteDateinummer
    Next lSprachNr
    
    'Dann die Funktion zum Fllen der Texte an die Source anhngen
            
    Print #iTmpSprachtexteDateinummer, "Function " & sFunktion1_Name _
        & "(sSprachcode As String, sInstVerzeichnis As String) As Boolean"
    Print #iTmpSprachtexteDateinummer, "'Dieser Code fr alle Sprachen wurde generiert. Er wird " _
        & "bei der nchsten Generierung wieder berschrieben."
    Print #iTmpSprachtexteDateinummer, "Dim iDateinummer As Integer"
    Print #iTmpSprachtexteDateinummer, "iDateinummer = FreeFile"
    Print #iTmpSprachtexteDateinummer, "Open sInstVerzeichnis & sKONFIGDIR & sSprachcode & sTXT" _
        & " For Input Access Read Shared As #iDateinummer"
    If lAnzahlZeilen > 0 Then
        Print #iTmpSprachtexteDateinummer, "Dim lZaehler As Long"
        Print #iTmpSprachtexteDateinummer, "Dim sZeile As String"
        Print #iTmpSprachtexteDateinummer, "For lZaehler = 1 To " & lAnzahlZeilen
        Print #iTmpSprachtexteDateinummer, "Line Input #iDateinummer, sZeile"
        Print #iTmpSprachtexteDateinummer, "Next lZaehler"
    End If
    
    'Jetzt fr jeden Symbolischen Namen einen Line Input in die Variable
    For lZaehler = 1 To UBound(gsSprachtexte, 2)
        If gsSprachtexte(0, lZaehler) <> sLEER Then
            Print #iTmpSprachtexteDateinummer, "Line Input #iDateinummer, " _
                & gsSprachtexte(0, lZaehler)
        End If
    Next lZaehler

    Print #iTmpSprachtexteDateinummer, "Close #iDateinummer"
    Print #iTmpSprachtexteDateinummer, sFunktion1_Name & " = True"
    Print #iTmpSprachtexteDateinummer, "End Function"
    Close #iTmpSprachtexteDateinummer

    'jetzt Ergebnis berprfen
    fbSprachtexte_ermitteln = True
    sText = sLEER
    If lZaehler = 0 Then
        MsgBox fsText(sMSG_KEINETEXTE _
            , sDateinameSprachtexte) _
            , vbExclamation, sTITEL_MACHEN
        fbSprachtexte_ermitteln = False
    Else
        For lZaehler = 0 To UBound(sSprachtextfehler, 2)
            For lSprachNr = 0 To UBound(gsSprachtexte, 1)
                If sSprachtextfehler(lSprachNr, lZaehler) <> sLEER Then
                    sText = sText & gsSprachtexte(0, lZaehler) & sSPACE _
                        & sSprachtextfehler(lSprachNr, lZaehler) & vbCr
                    fbSprachtexte_ermitteln = False
                End If
            Next lSprachNr
        Next lZaehler
        If fbSprachtexte_ermitteln = False Then
            MsgBox fsText(sMSG_FEHLERHAFTESPRACHTEXTE _
                , sDateinameSprachtexte _
                , sText) _
                , vbExclamation, sTITEL_MACHEN
        End If
    End If
    
End Function

Function fbEineSprachSource_erzeugen(sDateinameSprachtexte, sDateinameSprachsource As String _
, sVbName As String, sSprachcode As String, sFunktion1_Name As String) As Boolean
    'Die Funktion erzeugt aus gsSprachtexte die Source fr eine Sprache in sDateinameSprachsource
    'Das Ergebnis dieser Funktion ist False
    'Global:
    '   gsSprachtexte wird gelesen
    'Argumente:
    '   sDateinameSprachtexte = Dateiname der Basic-Source mit den Sprachtexten in gsSprachtexte
    '   sDateinameSprachsource = Dateiname der zu erzeugenden Sourcedatei mit Sprachtexten
    '   sVbName = Name des Modus fr Visual-Basic
    '   sSprachcode = Sprache der Texte (de, en)
    '   sFunktion1_Name = Name der Funktion zum Erzeugen der Sprachtexte
    'Rckgabewert:
    '   true = Sprachsource erzeugt
    'Effekt
    '   sDateinameSprachsource wirde erzeugt bzw. berschrieben.
    
    Dim lZaehler As Long
    Dim lSprachNr As Long
    Dim iSprachsourceDateinummer As Integer
    
    fbEineSprachSource_erzeugen = False
    iSprachsourceDateinummer = FreeFile
    Open sDateinameSprachsource For Output Access Write As #iSprachsourceDateinummer
    Print #iSprachsourceDateinummer, "Attribute VB_Name = " & Chr(34) & sVbName & Chr(34)
    Print #iSprachsourceDateinummer, "Rem Copyright (C) 2002 J.W.Schmitz-Hbsch"
    Print #iSprachsourceDateinummer, "Rem Dieser Code fr die Sprache " & sSprachcode & " wurde generiert."
    Print #iSprachsourceDateinummer, "Option Explicit"
    
    'Eine Sprache ermitteln
    For lSprachNr = 1 To UBound(gsSprachtexte, 1)
        If LCase(sSprachcode) = LCase(gsSprachtexte(lSprachNr, 0)) Then
            'Sprache gefunden
            For lZaehler = 1 To UBound(gsSprachtexte, 2)
                If gsSprachtexte(0, lZaehler) <> sLEER Then
                    Print #iSprachsourceDateinummer, fsText("Public Const (&1) As String = (&2)" _
                        , gsSprachtexte(0, lZaehler), gsSprachtexte(lSprachNr, lZaehler))
                End If
            Next lZaehler
            'fertig
            fbEineSprachSource_erzeugen = True
            Exit For
        End If
    Next lSprachNr
    
    Print #iSprachsourceDateinummer, "Function " & sFunktion1_Name _
        & "(sSprachcode As String, sInstVerzeichnis As String) As Boolean"
    Print #iSprachsourceDateinummer, sFunktion1_Name & " = False"
    Print #iSprachsourceDateinummer, "End Function"

    Close #iSprachsourceDateinummer
                
End Function

'Function fsTextAufbereiten(sText As String) As String
'    Const sESCAPE As String = "(&" 'Ist redundant in der Funktion fsText vorhanden
'    Dim lPos As Long
'    Dim lBisPos As Long
'    Dim sArbText As String
'    'Vor und nach (&x) muss ein Leerzeichen stehen
'    sArbText = sSPACE & sText & String(4, sSPACE)
'    lPos = InStr(1, sArbText, sESCAPE) 'Erstes Vorkommen von (& suchen
'    Do While lPos > 0 'Solange suchen bis lPos = 0 ist; dh. das Steuerzeichen nicht mehr gefunden wurde
'        If Mid(sArbText, lPos + 3, 1) = ")" Then
'            'lPos steht auf dem Zeichen (
'            If Mid(sArbText, lPos - 1, 1) <> sSPACE Then
'                'xxx(&1)yyy -> xxx (&1)yyy
'                sArbText = Left(sArbText, lPos - 1) & sSPACE & Mid(sArbText, lPos)
'                lPos = lPos + 4
'            Else
'                lPos = lPos + 3
'            End If
'            'lPos steht jetzt auf dem Zeichen )
'            If Mid(sArbText, lPos + 1, 1) <> sSPACE Then
'                sArbText = Left(sArbText, lPos) & sSPACE & Mid(sArbText, lPos + 1)
'                lPos = lPos + 1
'            End If
'        Else
'            lPos = lPos + 2
'        End If
'        lPos = InStr(lPos, sArbText, sESCAPE)  'Nchstes Vorkommen von (& suchen
'    Loop
'    fsTextAufbereiten = sArbText
'End Function

'===================================================================================================
'Ende.
'===================================================================================================

