Attribute VB_Name = "START_Schnittstelle4Inst"

Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   START
' Effekt:
'   Das Modul startet ein Modul des Installations-Add-In.
'   Der Name des gestarteten Moduls entspricht dem Namen dieses Add-In.
' Restriktionen:
'   Installation.dot muss vorhanden sein.
'   Unter Word 9.0 und 10.0 muss die Sicherheitsstufe niedrig oder Mittel sein, damit dieses
'   Add-In ausgefhrt werden kann.
' Entwicklung und Test:
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   11.12.2002  Erstellt fr Version 2.62
'   10.04.2005  berarbeitet

'===================================================================================================
'Prozeduren
'===================================================================================================
Sub AutoNew()

    Const sLEER As String = ""

    Const sTITEL_GS4WORD As String = "Gs4Word"
    Const sINSTALLATIONSADDIN As String = "Installation.dot"
    Const sINSTALLATIONSMODUL As String = "INST_Schnittstellen."
    Const sAUTOINSTALLATION As String = "AutoInstallation"
    Const sAUTODEINSTALLATION As String = "AutoDeinstallation"
    Const sDIALOGINSTALLATION As String = "DialogInstallation"
    Const sDIALOGDEINSTALLATION As String = "DialogDeinstallation"
    Const sADDIN_PREFIX As String = "Start_"
    Const sADDIN_DOT As String = ".dot"
    Const sADDIN_SETUP As String = "Setup.dot"
    
    Dim sMSG_FALSCHESMAKRO As String
    Dim sMSG_KEINEVERBINDUNGZUWORD As String
    Dim sMSG_INSTALLATIONSADDINFEHLT As String
    Dim sMSG_INSTALLATIONSMAKROFEHLT As String
    Dim sMSG_INSTALLATIONSMAKROSCHLIESSEN As String
    
    Dim sStartMakroName As String
    Dim sInstallationsProgrammName As String
    Dim sInstallationsMakroName As String
    Dim lPos As Long
    Dim iFehlerNummer As Integer
    Dim oWord As Object
    Dim vAddInName As Variant
        
    'Word maximiert anzeigen.
    'Nur dann wird die Sanduhr angezeigt und Fehlermeldungen erscheinen im Vordergrund
    Application.WindowState = wdWindowStateMaximize
    
    If LCase(Left(System.LanguageDesignation, 7)) = "deutsch" Then
        sMSG_FALSCHESMAKRO = "Das Add-In hat einen falschen Namen."
        sMSG_KEINEVERBINDUNGZUWORD = "Konnte keine Verbindung zu Word herstellen. Ist Microsoft-Word installiert?"
        sMSG_INSTALLATIONSADDINFEHLT = "Kann das erforderliche Add-In nicht laden. Ist es vorhanden?"
        sMSG_INSTALLATIONSMAKROFEHLT = "Kann das Word-Makro nicht ausfhren. Ist es im Add-In vorhanden?"
        sMSG_INSTALLATIONSMAKROSCHLIESSEN = "Kann das Add-In nicht schliessen. Wurde es schon geschlossen?"
    Else
        sMSG_FALSCHESMAKRO = "Wrong name of the Add-in."
        sMSG_KEINEVERBINDUNGZUWORD = "Could not communicate with Word. Is Microsoft Word installed?"
        sMSG_INSTALLATIONSADDINFEHLT = "Cannot load the necessary Add-in. Is it present?"
        sMSG_INSTALLATIONSMAKROFEHLT = "Cannot execute the Word macro. Is the Add-in available?"
        sMSG_INSTALLATIONSMAKROSCHLIESSEN = "Cannot close the Add-in. Is it already closed?"
    End If
    
    sInstallationsProgrammName = ThisDocument.Path & Application.PathSeparator & sINSTALLATIONSADDIN
    Select Case LCase(ActiveDocument.AttachedTemplate.Name)
    Case LCase(sADDIN_PREFIX & sDIALOGINSTALLATION & sADDIN_DOT), _
        LCase(sADDIN_SETUP)
        sInstallationsMakroName = sINSTALLATIONSMODUL & sDIALOGINSTALLATION
    Case LCase(sADDIN_PREFIX & sDIALOGDEINSTALLATION & sADDIN_DOT)
        sInstallationsMakroName = sINSTALLATIONSMODUL & sDIALOGDEINSTALLATION
    Case LCase(sADDIN_PREFIX & sAUTOINSTALLATION & sADDIN_DOT)
        sInstallationsMakroName = sINSTALLATIONSMODUL & sAUTOINSTALLATION
    Case LCase(sADDIN_PREFIX & sAUTODEINSTALLATION & sADDIN_DOT)
        sInstallationsMakroName = sINSTALLATIONSMODUL & sAUTODEINSTALLATION
    Case Else
        MsgBox sMSG_FALSCHESMAKRO _
            & vbCr & "(" & ActiveDocument.AttachedTemplate.Name & ")" _
            , vbExclamation, sTITEL_GS4WORD
        Exit Sub
    End Select
    
    'Vorhandes Gs4word AddIn deaktivieren, damit es vom Installations-addIn gelscht werden kann
    On Error Resume Next
    AddIns("Gs4Word.dot").Installed = False
    On Error GoTo 0
        
    'Hinweise lschen
    Selection.WholeStory
    Selection.Delete
    
    'Neuen Hinweis anzeigen
    sStartMakroName = ActiveDocument.AttachedTemplate.Name
    If LCase(Right(sStartMakroName, 4)) = ".dot" Then
        sStartMakroName = Left(sStartMakroName, Len(sStartMakroName) - 4)
    End If
    Selection.Collapse Direction:=wdCollapseEnd
    Selection.InsertAfter (sTITEL_GS4WORD & " - " & sStartMakroName)
    Selection.InsertAfter (vbCrLf)
    Selection.Font.Size = 14
    Selection.Font.Bold = True
    Selection.Collapse Direction:=wdCollapseEnd
    Selection.InsertAfter (vbCrLf & "Bitte warten...")
    Selection.InsertAfter (vbCrLf & "Please wait...")
    Selection.InsertAfter (vbCrLf)
    Selection.Font.Size = 12
    Selection.Font.Bold = False
    Selection.LanguageID = wdNoProofing
    Selection.Collapse Direction:=wdCollapseEnd 'reduziert die Auswahl auf das Ende
        
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox sMSG_KEINEVERBINDUNGZUWORD, vbExclamation, sTITEL_GS4WORD
        Exit Sub
    End If
    
    'Installations-Add-In laden
    On Error Resume Next
    oWord.AddIns.Add FileName:=sInstallationsProgrammName, Install:=True
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer <> 0 Then
        MsgBox sMSG_INSTALLATIONSADDINFEHLT _
            & vbCr & "(" & sInstallationsProgrammName & ")" _
            , vbExclamation, sTITEL_GS4WORD
    Else
        'Installations-Add-In minimiert ausfhren
        oWord.Visible = True 'Word Applikation anzeigen, bei False sieht man nichts!
        oWord.WindowState = wdWindowStateMinimize
        On Error Resume Next
        oWord.Run MacroName:=sInstallationsMakroName
        iFehlerNummer = Err.Number
        On Error GoTo 0
        If iFehlerNummer <> 0 Then
            MsgBox sMSG_INSTALLATIONSMAKROFEHLT _
                & vbCr & "(" & sInstallationsProgrammName _
                & " - " & sInstallationsMakroName & ")" _
                , vbExclamation, sTITEL_GS4WORD
        Else
            'Installations-Add-In entladen
            On Error Resume Next
            oWord.AddIns(sInstallationsProgrammName).Delete
            iFehlerNummer = Err.Number
            On Error GoTo 0
            'Wenn die aufgerufene Word-Instanz schon beendet wurde, ist das OK
            'If iFehlerNummer <> 0 Then
            '    MsgBox sMSG_INSTALLATIONSMAKROSCHLIESSEN _
            '        & vbCr & "(" & sInstallationsProgrammName & ")" _
            '        , vbExclamation, sTITEL_GS4WORD
            'End If
        End If
    End If
    
    'Word beenden
    'Wenn die aufgerufene Word-Instanz schon beendet wurde, ist das OK
    On Error Resume Next
    oWord.Quit
    Set oWord = Nothing
    On Error GoTo 0
    
    Application.Quit SaveChanges:=wdDoNotSaveChanges
            
End Sub

Function fsTraceZeileAusgeben(sTraceZeile As String) As Boolean
    'Dummy Funktion zum Trace, falls dieser aktiv ist.

End Function

'===================================================================================================
'Ende.
'===================================================================================================






